Package: littler
Type: Package
Title: R at the Command-Line via 'r'
Version: 0.3.23
Date: 2026-04-12
Authors@R: c(person("Dirk", "Eddelbuettel", role = c("aut", "cre"), email = "edd@debian.org",
                    comment = c(ORCID = "0000-0001-6419-907X")),
             person("Jeff", "Horner", role = "aut",
                    comment = "(2006-2008)"))
Description: A scripting and command-line front-end
 is provided by 'r' (aka 'littler') as a lightweight binary wrapper around
 the GNU R language and environment for statistical computing and graphics.
 While R can be used in batch mode, the r binary adds full support for
 both 'shebang'-style scripting (i.e. using a  hash-mark-exclamation-path
 expression as the first line in scripts) as well as command-line use in
 standard Unix pipelines. In other words, r provides the R language without
 the environment.
URL: https://github.com/eddelbuettel/littler,
        https://dirk.eddelbuettel.com/code/littler.html,
        https://eddelbuettel.github.io/littler/
BugReports: https://github.com/eddelbuettel/littler/issues
License: GPL (>= 2)
OS_type: unix
SystemRequirements: libR
Suggests: simplermarkdown, docopt, rcmdcheck, whoami
VignetteBuilder: simplermarkdown
RoxygenNote: 5.0.1
NeedsCompilation: yes
Packaged: 2026-04-12 14:00:54 UTC; edd
Author: Dirk Eddelbuettel [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6419-907X>),
  Jeff Horner [aut] ((2006-2008))
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Repository: CRAN
Date/Publication: 2026-04-12 14:10:02 UTC
Built: R 4.5.2; aarch64-apple-darwin20; 2026-04-15 04:55:41 UTC; unix

Package: littler
Type: Package
Title: R at the Command-Line via 'r'
Version: 0.3.23
Date: 2026-04-12
Authors@R: c(person("Dirk", "Eddelbuettel", role = c("aut", "cre"), email = "edd@debian.org",
                    comment = c(ORCID = "0000-0001-6419-907X")),
             person("Jeff", "Horner", role = "aut",
                    comment = "(2006-2008)"))
Description: A scripting and command-line front-end
 is provided by 'r' (aka 'littler') as a lightweight binary wrapper around
 the GNU R language and environment for statistical computing and graphics.
 While R can be used in batch mode, the r binary adds full support for
 both 'shebang'-style scripting (i.e. using a  hash-mark-exclamation-path
 expression as the first line in scripts) as well as command-line use in
 standard Unix pipelines. In other words, r provides the R language without
 the environment.
URL: https://github.com/eddelbuettel/littler,
        https://dirk.eddelbuettel.com/code/littler.html,
        https://eddelbuettel.github.io/littler/
BugReports: https://github.com/eddelbuettel/littler/issues
License: GPL (>= 2)
OS_type: unix
SystemRequirements: libR
Suggests: simplermarkdown, docopt, rcmdcheck, whoami
VignetteBuilder: simplermarkdown
RoxygenNote: 5.0.1
NeedsCompilation: yes
Packaged: 2026-04-12 14:00:54 UTC; edd
Author: Dirk Eddelbuettel [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6419-907X>),
  Jeff Horner [aut] ((2006-2008))
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Repository: CRAN
Date/Publication: 2026-04-12 14:10:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-26 21:15:29 UTC; unix

## littler: A scripting and command-line front-end for GNU R

[![CI](https://github.com/eddelbuettel/littler/workflows/ci/badge.svg)](https://github.com/eddelbuettel/littler/actions?query=workflow%3Aci)
[![License](https://img.shields.io/badge/license-GPL%20%28%3E=%202%29-brightgreen.svg?style=flat)](https://www.r-project.org/Licenses/GPL-2)
[![CRAN](https://www.r-pkg.org/badges/version/littler)](https://cran.r-project.org/package=littler)
[![r-universe](https://eddelbuettel.r-universe.dev/badges/littler)](https://eddelbuettel.r-universe.dev/littler)
[![Dependencies](https://tinyverse.netlify.app/badge/littler)](https://cran.r-project.org/package=littler)
[![Downloads](https://cranlogs.r-pkg.org/badges/littler?color=brightgreen)](https://www.r-pkg.org/pkg/littler)
[![Last Commit](https://img.shields.io/github/last-commit/eddelbuettel/littler)](https://github.com/eddelbuettel/littler)
[![Documentation](https://img.shields.io/badge/documentation-is_here-blue)](https://eddelbuettel.github.io/littler/)

### So What Is It For?

```r
#!/usr/bin/env r              ## for use in scripts

other input | r               ## for use in pipes

r somefile.R                  ## for running files

r -e 'expr'                   ## for evaluating expressions

r --help                      ## to show a quick synopsis
```

### Examples?

Plenty. See the [(older) examples
vignette](https://cran.r-project.org/package=littler/vignettes/littler-examples.html) for a full set
of introductory examples. Also see the [examples/
directory](https://github.com/eddelbuettel/littler/tree/master/inst/examples) for a full 63 (!!)
example scripts (as of early 2026), as well as maybe the [older tests
directory](https://github.com/eddelbuettel/littler/tree/master/inst/script-tests) both of which are
installed with the package.

Some scripts I use daily or near daily (in alphabetical order):

```sh
build.r                                # builds from the current directory
c4c.r                                  # submits current directory to winbuilder
compAttr.r                             # run compileAttributes() for a Rcpp package
dratInsert.r 1.2-3.tar.gz -r /srv      # inserts package into drat repo
install.r abc def                      # installs packages abc and def
install.r abc_1.2-3.tar.gz             # installs given tarball
install2.r -l /tmp/lib abc def         # installs abc and def into /tmp/lib
rcc.r abc_1.2-3.tar.gz                 # run's R CMD check via Gabor's rcmdcheck
render.r foo.Rmd                       # calls rmarkdown::render()
roxy.r                                 # run roxygenize() for a package (only Rd creation)
update.r                               # updates any currently installed packages
installGithub.r repo/package           # install directly from GitHub
crup.r abc_1.2-3.tar.gz                # CRAN upload of package
```

### Installation

#### Version 0.3.0 or later

The package resides on the CRAN network and can be installed via

```
install.packages("littler")
```

Note that the package states `OS_type: unix`. It works great on all Linux
variants, with a naming caveat on macOS (see below and the [FAQ
vignettes](https://github.com/eddelbuettel/littler/blob/master/vignettes/littler-faq.md))
and not at all on Windows (but could be ported just like
[RInside](https://github.com/eddelbuettel/rinside) has been--the two show
architectural similarities).

#### Previous Versions up to 0.2.3

In general, simply running the script `bootstrap` will configure and build the
executable. Running `make install` (possibly as `sudo make install`) will
install the resulting binary.

On Linux systems, ensure you have the `autotools-dev` package (or its
equivalent on non-Debian/Ubuntu systems).  On OS X, you may need to run `brew
install automake autoconf` to get all the tools.

#### Alternate Naming

On some operating systems such as OS X, `r` is not different from `R`.  As
this risks confusing the main binary `R` for the R system with our smaller
scripting frontend `r`, we suggest to consider running `configure
--program-prefix="l"` which this leads to installation of a binary `lr`
instead of `r`.

#### Alternate R Version

As littler uses autoconf its `AC_PATH_PROG()` macro to find `R`, one can
simply adjust the `PATH` when calling `configure` (or, rather, `bootstrap`)
to have another version of R used. For example, on a server with R-devel in
this location, the following builds littler using this R-devel version:
`PATH="/usr/local/lib/R-devel/bin/:$PATH" ./bootstrap`.

### More Information

For more information about littler, please see

* [Dirk's littler page](https://dirk.eddelbuettel.com/code/littler.html)
* [Dirk's page with littler examples](https://dirk.eddelbuettel.com/code/littler.examples.html)

(but note that the latter now overlaps with the
[example vignette](https://cran.r-project.org/package=littler/vignettes/littler-examples.html)).

### Authors

Jeff Horner (2006 to 2008) and Dirk Eddelbuettel (since 2006)

### License

GPL (>= 2)

## littler: A scripting and command-line front-end for GNU R

[![Build Status](https://travis-ci.org/eddelbuettel/littler.png)](https://travis-ci.org/eddelbuettel/littler)
[![License](https://img.shields.io/badge/license-GPL%20%28%3E=%202%29-brightgreen.svg?style=flat)](https://www.gnu.org/licenses/gpl-2.0.html)
[![CRAN](https://www.r-pkg.org/badges/version/littler)](https://cran.r-project.org/package=littler)
[![Dependencies](https://tinyverse.netlify.com/badge/littler)](https://cran.r-project.org/package=littler)
[![Downloads](https://cranlogs.r-pkg.org/badges/littler?color=brightgreen)](https://www.r-pkg.org/pkg/littler) 
[![Last Commit](https://img.shields.io/github/last-commit/eddelbuettel/littler)](https://github.com/eddelbuettel/littler)
[![Documentation](https://img.shields.io/badge/documentation-is_here-blue)](https://eddelbuettel.github.io/littler/)

### So What Is It For?

```r
#!/usr/bin/env r              ## for use in scripts

other input | r               ## for use in pipes

r somefile.R                  ## for running files

r -e 'expr'                   ## for evaluating expressions

r --help                      ## to show a quick synopsis
```

### Examples? 

Plenty. See the [examples vignette](https://cran.r-project.org/package=littler/vignettes/littler-examples.html)
for a full set of introductory examples. Also 
see the [examples/ directory](https://github.com/eddelbuettel/littler/tree/master/inst/examples) for a full 28
example scripts, as well as maybe the
[older tests directory](https://github.com/eddelbuettel/littler/tree/master/inst/script-tests)
both of which are installed with the package.

Some scripts I uses daily or near daily (in alphabetical order):

```
build.r                                ## builds from the current directory
c4c.r                                  ## submits current directory to winbuilder
compAttr.r                             ## run compileAttributes() for a Rcpp package
dratInstert.r 1.2-3.tar.gz -r /srv     ## inserts package into drat repo
install.r abc def                      ## installs packages abc and def
install.r abc_1.2-3.tar.gz             ## installs given tarball
install2.r -l /tmp/lib abc def         ## installs abc and def into /tmp/lib
rcc.r abc_1.2-3.tar.gz                 ## run's R CMD check via Gabor's rcmdcheck
render.r foo.Rmd                       ## calls rmarkdown::render()
roxy.r                                 ## run roxyenize() for a package (only Rd creation)
update.r                               ## updates any currently installed packages 
```

### Installation

#### Version 0.3.0 or later

The package resides on the CRAN network and can be installed via

```
install.packages("littler")
```

#### Previous Versions up to 0.2.3 

In general, simply running the script `bootstrap` will configure and build the
executable. Running `make install` (possibly as `sudo make install`) will
install the resulting binary.

On Linux systems, ensure you have the `autotools-dev` package (or its
equivalent on non-Debian/Ubuntu systems).  On OS X, you may need to run `brew
install automake autoconf` to get all the tools. 

#### Alternate Naming

On some operating systems such as OS X, `r` is not different from `R`.  As
this risk confusing the main binary `R` for the R system with our smaller
scripting frontend `r`, we suggest to consider running `configure
--program-prefix="l"` which this leads to installation of a binary `lr`
instead of `r`.

#### Alternate R Version

As littler uses autoconf its `AC_PATH_PROG()` macro to find `R`, one can
simply adjust the `PATH` when calling `configure` (or, rather, `bootstrap`)
to have another version of R used. For example, on a server with R-devel in
this location, the following builds littler using this R-devel version:
`PATH="/usr/local/lib/R-devel/bin/:$PATH" ./bootstrap`. 

### More Information

For more information about littler, please see

* [Dirk's littler page](https://dirk.eddelbuettel.com/code/littler.html)
* [Dirk's page with littler examples](https://dirk.eddelbuettel.com/code/littler.examples.html)

(but note that the latter now overlaps with the
[example vignette](https://cran.r-project.org/package=littler/vignettes/littler-examples.html)).

### Authors

Jeff Horner (2006 to 2008) and Dirk Eddelbuettel (since 2006)

### License

GPL (>= 2)

#!/usr/bin/env r
##
##  Convert a DOI to it bibtext field
##
##  Copyright (C) 2024  Dirk Eddelbuettel
##
##  Released under GPL (>= 2)
##
##  With thanks to https://bsky.app/profile/rmcelreath.bsky.social/post/3knkqvogwbc25

## load docopt package from CRAN
library(docopt)

if (!requireNamespace("httr", quietly=TRUE))
    stop("Please install 'httr' from CRAN.", call. = FALSE)

library(httr)

## configuration for docopt
doc <- "Usage: doi2bib.r [-h] [-x] DOI...

-h --help             show this help text
-x --usage            show help and short example usage"

opt <- docopt(doc)          # docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  doi2bib.r 10.1002/evan.10110 10.1007/978-1-4614-6868-4

doi2bib.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

for (arg in opt$DOI) {
    res <- GET(paste0("https://doi.org/", arg),
               add_headers(Accept="application/x-bibtex"))
    cat(rawToChar(res$content))
}

#!/usr/bin/env r
#
# Minimal rhub::check() wrapper using rchk()
#
# Copyright (C) 2016 - 2019  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

rhub::check(".", "ubuntu-rchk", check_args="--no-manual --no-vignettes")

#!/usr/bin/env r

library(docopt)

## configuration for docopt
doc <- "Usage: kitten.r [-t TYPE] [-b] [-p] [-h] [-x] PACKAGE

-t --type TYPE      type of kitten: plain, rcpp, arma, eigen. [default: plain]
-b --bunny          install roxygen2 documentation example and roxygenize (only for plain)
-p --puppy          invoke tinytest::puppy to set up testing (only for plain)
-h --help           show this help text
-x --usage          show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  kitten.r

kitten.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

haswhoami <- requireNamespace("whoami", quietly=TRUE)
author <- if (haswhoami) whoami::fullname("Your Name") else "Your Name"
email <- if (haswhoami) whoami::email_address("your@email.com") else "your@email.com"
githubuser <- if (haswhoami) whoami::gh_username() else NA_character_

## maybe support path, author, maintainer, email, license, ... command-line options
ign <- switch(opt$type,
              plain = pkgKitten::kitten(opt$PACKAGE,
                                        author=author, email=email, githubuser=githubuser,
                                        puppy=opt$puppy, bunny=opt$bunny),
              rcpp = Rcpp::Rcpp.package.skeleton(opt$PACKAGE,
                                                 author=author, email=email, githubuser=githubuser),
              arma = RcppArmadillo::RcppArmadillo.package.skeleton(opt$PACKAGE, author=author,
                                                                   email=email, githubuser=githubuser),
              eigen = RcppEigen::RcppEigen.package.skeleton(opt$PACKAGE))

if (opt$puppy && opt$type != "plain") {
    stopifnot(requireNamespace("tinytest", quietly=TRUE))
    tinytest::puppy(opt$PACKAGE)
}

#!/usr/bin/env r
#
# Another example to check one or more packages, with option parsing
#
# Copyright (C) 2015 - 2023  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: check.r [-h] [-x] [--as-cran] [--repo REPO] [--no-manvig] [--install-deps] [--install-kitchen] [--deb-pkgs PKGS...] [--use-sudo] [--library LIB] [--setwd DIR] [TARGZ ...]

-a --as-cran          customization similar to CRAN's incoming [default: FALSE]
-r --repo REPO        repository to use, or NULL for file [default: https://cloud.r-project.org]
-n --no-manvig        set the '--no-manual --no-vignettes' options [default: FALSE]
-i --install-deps     also install packages along with their dependencies [default: FALSE]
-k --install-kitchen  even install packages 'kitchen sink'-style up to suggests [default: FALSE]
-l --library LIB      when installing use this library [default: /usr/local/lib/R/site-library]
-s --setwd DIR        change to this directory before undertaking the test [default: ]
-d --deb-pkgs PKGS    also install binary .deb packages with their dependencies [default: FALSE]
-u --use-sudo         use sudo when installing .deb packages [default: FALSE]
-h --help             show this help text
-x --usage            show help and short example usage"

## docopt parsing
opt <- docopt(doc)

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  check.r -a -i -s /tmp myPkg_1.2-3.tar.gz    # run a check --as-cran with depends in /tmp
                                              # for package myPkg_1.2-3.tar.gz

check.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

args <- character()
if (opt$as_cran) args <- c(args, "--as-cran")
if (opt$no_manvig) args <- c(args, "--no-manual", "--no-vignettes")

if (!is.null(opt$libdir)) .libPaths(opt$libdir)

r <- getOption("repos")
r["CRAN"] <- opt$repo
options(repos = r)

hasRcmdcheck <- requireNamespace("rcmdcheck", quietly=TRUE)
if (hasRcmdcheck) suppressMessages(library("rcmdcheck"))

## helper functions
checkArg <- function(p, args) {
    if (hasRcmdcheck) {
        #if (length(args) == 0) args <- ""
        res <- rcmdcheck(p, args=args)
    } else {
        tools:::.check_packages(c(p, args))
        res <- NULL
    }
    res
}

## helper function which switches to local (ie NULL) repo if matching file is presented
installArg <- function(p, lib, rep) {
    p <- gsub("_.*tar\\.gz$", "", p)
    install.packages(pkgs=p,
                     lib=lib,
                     repos=rep,
                     dependencies=if(opt$install_kitchen)
                                      c("Depends", "Imports", "LinkingTo", "Suggests")
                                  else
                                      TRUE
                     )
}

## if binary .deb files are to be installed first:
if (length(opt$deb_pkgs) > 1 || opt$deb_pkgs != FALSE) {
    cmd <- paste0(if (opt$use_sudo) "sudo " else "",
                 "apt-get install -y ", paste(opt$deb_pkgs, collapse=" "))
    system(cmd)
}

## if dependencies (or even suggests) are to be installed first:
if (opt$install_deps || opt$install_kitchen) sapply(opt$TARGZ, installArg, opt$lib, opt$repo)

## change directory if a target directory was given
if (!is.null(opt$setwd)) setwd(opt$setwd)

## installation given selected options and arguments
sapply(opt$TARGZ, checkArg, args)

#!/usr/bin/env r
#
# A simple example to install from RSPM/PPM/P3M
#
# Copyright (C) 2020 - present  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

if (Sys.info()[["sysname"]] != "Linux")
    stop(paste("Currently only supported on Linux.",
               "Please get in touch if you want to / can help on macOS"), call.=FALSE)

code <- "<unknown>"
if (file.exists("/etc/os-release")) {   # next block borrowed from my chshli package on GitHub
    osrel <- read.table("/etc/os-release", sep="=", row.names=1, col.names=c("key","value"))
    if ("REDHAT_SUPPORT_PRODUCT" %in% rownames(osrel)) {
        # 'centos7' for CentOS/RHEL 7, 'centos8' for CentOS/RHEL 8 and Fedora
        ver <- osrel["REDHAT_SUPPORT_PRODUCT_VERSION", "value"]
        code <- paste0("centos", min(as.numeric(ver), 8))
    } else if ("VERSION_CODENAME" %in% rownames(osrel)) {
        code <- osrel["VERSION_CODENAME", "value"]
    }
}
if ((code == "<unknown>") && (Sys.which("lsb_release") != "")) {
    code <- system("lsb_release -c | awk '{print $2}'", intern=TRUE)
}

## configuration for docopt
doc <- paste0("Usage: install(RSPM|PPM|P3M).r [-c code] [-l libloc] [-h] [-x] ARGS...

-c --code ARG    set code name for distribution [default: ", code, "]
-l --libloc ARG  location in which to install [default: ", .libPaths()[1], "]
-h --help        show this help text
-x --usage       show help and short example usage

Note that RSPM/PPM/P3M support may be somewhat experimental. There may not be binaries
for every possibly OS, distibution, and R version. Please file issue tickets at the
Github repo for littler if you can contribute additional checks and values.

As RSPM has been renamed to PPM and then P3M, we now install the script thrice via hardlinks.
")

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n")
    cat("Basic usage:

  installRSPM.r digest	            # install digest for default release '", code, "'
  installPPM.r -c jammy digest      # install digest for Ubuntu 'jammy'
  installP3M.r -c bookworn digest   # install digest for Debian 'bookworm'

install(RSPM|PPM|P3M).r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n", sep="")
    q("no")
}

if (!is.null(opt$libloc)) .libPaths(opt$libloc)

r <- getOption("repos")
r["CRAN"] <- paste0("https://p3m.dev/all/__linux__/", opt$code, "/latest")
options(repos = r)
options(HTTPUserAgent = sprintf("R/%s R (%s)", getRversion(),
                                paste(getRversion(), R.version$platform, R.version$arch, R.version$os)))

invisible(sapply(opt$ARGS, function(r) install.packages(r)))

#!/usr/bin/env r
##
##  A wrapper for tools::check_package_url (and check_package_dois)
##
##  Copyright (C) 2025 - present  Dirk Eddelbuettel
##
##  Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

doc <- "Usage: checkPackageUrls.r [-s] [-v] [-h] [DIRS ...]

-s --skip-dois    do not run 'check_package_dois()' as well [default: FALSE]
-v --verbose      run in verbose mode mode [default: FALSE]
-h --help         show this help text

Simple wrapper to 'tools::check_package_urls(...)'.
"

opt <- docopt(doc)

if (length(opt$DIRS) == 0) opt$DIRS <- "." 	# default argument current directory

for (d in opt$DIRS) {
    tools::check_package_urls(d, isTRUE(opt$verbose))
    if (isFALSE(opt$skip_dois)) tools::check_package_dois(d, isTRUE(opt$verbose))
}

#!/usr/bin/env r
##
##  Retrieve R_HOME information
##
##  See help(R.home) for details, use arguments "bin", "lib", "etc", ...
##
##
##  Note that in shell scripts you may want something like
##
##     ## Set R_HOME, respecting an environment variable if set
##     : ${R_HOME=$(R RHOME)}
##
##  after which expansions use as in   ${R_HOME}/bin/Rscript   works
##
##  In Makefiles you want a similar use via a shell call:
##
##     ${R_HOME}/bin/Rscript
##
##  as R_HOME is already set with an 'R CMD ...' call (!!). On Windows
##  do something like
##
##     PKG_LIBS = $(shell "${R_HOME}/bin${R_ARCH_BIN}/Rscript.exe" -e "RcppGSL:::LdFlags()")
##
##  to pick up the architecture flag
##
##
##  Copyright (C) 2015         Dirk Eddelbuettel
##
##  Released under GPL (>= 2)

if (is.null(argv) | length(argv) < 1) argv <- "home"

cat(sapply(argv, R.home))

##
##  littler - Provides hash-bang (#!) capability for R (www.r-project.org)
##
##  Copyright (C) 2006 - 2016  Jeffrey Horner and Dirk Eddelbuettel
##
##  littler is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##

s <- Sys.info()
if (is.null(s)) q()
if (s[1] != "Linux") q()
ldp <- strsplit(Sys.getenv('LD_LIBRARY_PATH'),':')[[1]]
ldp <- ldp[which(ldp != "")]
cat(paste(paste0('-Wl,-rpath,', ldp), collapse=" "), "\n")

#!/usr/bin/r
##
##  Show all dependencies of a package containing native ("compiled") code
##
##  Copyright (C) 2021 - present  Dirk Eddelbuettel
##
##  Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

if (!requireNamespace("data.table", quietly=TRUE))
    stop("The 'data.table' package is required. Please install it.", call.=FALSE)

doc <- "Usage: urlUpdate.r [-c] [-n] [-h] PACKAGE

-c --compact        compact, print only package vector
-n --nonrecursive   non-recursive dependencies [default: FALSE]
-h --help           show this help text

Simple wrapper around 'tools::CRAN_package_db()' and 'tools::package_depdencies()'.
"

opt <- docopt(doc)

suppressMessages(library(data.table))

pkg <- opt$PACKAGE
rec <- !opt$nonrecursive
db <- setDT(tools::CRAN_package_db(), key="Package")
revs <- data.table(Package=tools::package_dependencies(pkg, recursive=rec, db=db)[[1]], key="Package")

res <- db[revs, .(Package,Version,Priority,NeedsCompilation)][
    is.na(Priority)==TRUE & is.na(Version)==FALSE & NeedsCompilation=="yes"][
   ,.(Package,Version)]

if (opt$compact) {
    cat(paste(res[[1]], collapse=" "), "\n")
} else {
    options("datatable.print.nrows"=nrow(res))
    print(res)
}

#!/usr/bin/env r
#
# Simple r2u helper frontend
#
# Copyright (C) 2022         Dirk Eddelbuettel
#
# Released under GPL (>= 2)

library(docopt)

doc <- "Usage: r2u.r [--release DIST] [--debug] [--verbose] [--force] [--uncache] [--help] CMD [...]

Options:
-r --release DIST   release distribution to use, one of 'focal' or 'jammy' [default: jammy]
-d --debug          boolean flag for extra debugging
-v --verbose        boolean flag for verbose operation
-f --force          boolean flag to force build
-x --xvfb           boolean flag to build under 'xvfb' (x11 virtual framebuffer)
-u --uncache        remove the cached meta data archives of available packages
-h --help           show this help text

Cmd:
build        updates packages
lastsync     reports most recent binary package sync

Simple wrapper to 'r2u::buildUpdatedPackages(distro)'. The 'CMD' has to (for now)
be 'build (for buildUpdatedPackages)'.
"

opt <- docopt(doc)

if (!is.finite(match(opt$release, c("focal", "jammy"))))
    stop("Unknown distro '", opt$release, "'.", call. = FALSE)

if (!is.finite(match(opt$CMD, c("build", "last", "count", "table"))))
    stop("Unknown command '", opt$CMD, "'.", call. = FALSE)

if (is.finite(match(opt$CMD, "build"))) {
    library(r2u)
    if (opt$uncache) {
        for (db in c(r2u:::.defaultCRANDBFile(), r2u:::.defaultAPFile()))
            if (file.exists(db)) unlink(db)
        r2u:::.loadDB()
        r2u:::.loadAP()
    }
    buildUpdatedPackages(opt$release,
                         opt$debug,
                         opt$verbose,
                         opt$force,
                         opt$xvfb)
} else if (is.finite(match(opt$CMD, "last"))) {
    D <- RcppSimdJson::fload("https://packagemanager.rstudio.com/__api__/sources/1/transactions")
    ts <- anytime::utctime(D[1,"completed"])
    dh <- as.numeric(difftime(Sys.time(), ts, units="hours"))
    un <- "days"
    if (dh <= 3) un <- "mins" else if (dh < 25) un <- "hours"
    cat("RSPM last updated", format(round(difftime(Sys.time(), ts, units=un),1)), "ago\n")
} else if (is.finite(match(opt$CMD, "count"))) {
    ll <- readLines(pipe("bash -c ~/bin/web_who_what | grep '.*cranapt\\/pool\\/dists\\/.*\\/r-.*\\.deb$'"))
    cat(length(ll), ".deb files downloaded\n")
} else if (is.finite(match(opt$CMD, "table"))) {
    con <- pipe("bash -c ~/bin/web_who_what | grep '.*cranapt\\/pool\\/dists\\/.*\\/r-.*\\.deb$'")
    ll <- readLines(con)
    close(con)
    tt <- table(gsub(".*r-(cran|bioc)-(.*)_\\d+.*", "\\2", ll, perl=TRUE))
    print(head(tt[order(-tt)], 10))
}

#!/usr/bin/env -S r -t
#
# testthat::test_file wrapper
#
# Copyright (C) 2019 - 2024  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

if (!requireNamespace("testthat", quietly=TRUE))
    stop("Please install 'testthat' from CRAN.", call. = FALSE)

## load docopt and tinytest from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

## configuration for docopt
doc <- "Usage: tttf.r [-l LIB] [-s FILE] [-c] [-d] [-h] [-x] ARG

-l --library LIB    load named library, LIB can be comma-separated
-s --source FILE    source a named file
-d --loadall        run `devtools::load_all()`
-c --ci             set environment variable CI to TRUE [default: FALSE]
-h --help           show this help text
-x --usage          show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where ARG can be a package directory.

Examples:
  tttf.r test-testfile.r              # run test_file() on the given file

tttf.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (!is.null(opt$library)) {
    for (s in strsplit(opt$library, ",")[[1]]) {
        library(s, character.only=TRUE, verbose=TRUE)
    }
}

if (!file.exists(opt$ARG)) {
    stop("No such file.", call. = FALSE)
}

if (!is.null(opt$source) && file.exists(opt$source)) {
    source(opt$source)
}

if (opt$ci) {
    Sys.setenv(CI="TRUE")
}

if (opt$loadall) {
    suppressMessages(devtools::load_all())
}

testthat::test_file(path=opt$ARG)

#!/usr/bin/env r
##
##  A simple example to builds a source tar.gz file
##
##  Copyright (C) 2017 - 2021  Dirk Eddelbuettel
##
##  Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

doc <- "Usage: build.r [-f] [-h] [PACKAGES ...]

-f --fast      skip building vignettes and manual
-h --help      show this help text

Simple wrapper to 'R CMD build ...' which calls 'tools:::.build_packages()' just like
the 'R CMD build' invocation.
"

opt <- docopt(doc)

if (length(opt$PACKAGES) == 0) opt$PACKAGES <- "." 	# default argument current directory

argv <- if (opt$fast) c("--no-build-vignettes", "--no-manual", opt$PACKAGES) else opt$PACKAGES

extraargs <- c("--compact-vignettes=both", "--resave-data", argv)

tools:::.build_packages(extraargs, no.q=interactive())

#!/usr/bin/env r
#
# a simple example to test one or more installed packages

## load docopt package from CRAN
library(docopt)
library(tools)

## configuration for docopt
doc <- "Usage: test.r [-l LIBLOC] [-o OUTDIR] [-t TYPES] [-s SRCDIR] [-h] [PACKAGES ...]

-l --libloc LIBLOC  location where package(s) are installed [default: NULL]
-o --outdir OUTDIR  the directory into which to write output files, should exist. [default: .]
-t --types TYPES    type(s) of tests to be done. [default: c('examples', 'tests', 'vignettes')]
-s --srcdir SRCDIR  Optional directory to look for .save files [default: NULL]
-h --help           show this help text"


## docopt parsing
opt <- docopt(doc)

## installation given selected options and arguments
testInstalledPackage(pkg = opt$PACKAGES,
                     lib = opt$libloc,
                  outDir = opt$outdir,
                   types = opt$types,
                  srcdir = opt$srcdir)

#!/usr/bin/env r
#
# ciw wrapper
#
# Copyright (C) 2024  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

if (!requireNamespace("ciw", quietly=TRUE))
    stop("Please install 'eddelbuettel/ciw' from GitHub.", call. = FALSE)

## load docopt and cranincoming
suppressMessages({
    library(ciw) 		        # at GitHub under eddelbuettel for now
    library(docopt)             # we need docopt (>= 0.3) as on CRAN
})

## configuration for docopt
doc <- "Usage: ciw.r [-h] [-x] [-a] [-m] [-i] [-t] [-p] [-w] [-r] [-s] [-n] [-u] [-l rows] [-g age] [-z] [ARG...]

-m --mega           use 'mega' mode of all folders (see --usage)
-i --inspect        visit 'inspect' folder
-t --pretest        visit 'pretest' folder
-p --pending        visit 'pending' folder
-w --waiting        visit 'waiting' folder
-r --recheck        visit 'recheck' folder
-a --archive        visit 'archive' folder
-n --newbies        visit 'newbies' folder
-u --publish        visit 'publish' folder
-s --skipsort       skip sorting of aggregate results by age
-l --lines rows     print top 'rows' of the result object [default: 50]
-g --max age        print only package less than 'age' hours old [default: 168]
-z --ping           run the connectivity check first
-h --help           show this help text
-x --usage          show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where ARG... can be one or more file name, or directories or package names.

Examples:
  ciw.r -ip                            # run in 'inspect' and 'pending' mode
  ciw.r -a                             # run with mode 'auto' resolved in incoming()
  ciw.r                                # run with defaults, same as '-itpwr'

When no argument is given, 'auto' is selected which corresponds to 'inspect', 'waiting',
'pending', 'pretest', and 'recheck'.

Folder selecting arguments are cumulative. Selecting '-m' or '--mega' is a single selections
of all folders that are not per-user folders (i.e. 'inspect', 'waiting', 'pending', 'pretest',
'recheck', 'archive', 'newbies', 'publish').

ciw.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

args <- character() 			# start with no arguments

folders <-  c("inspect", "waiting", "pending", "pretest", "recheck", "archive", "newbies", "publish")

for (dir in folders) 			# grow folder set as a select
    if (opt[[dir]])
        args <- c(args, dir)

if (opt$mega) args <- folders	# or respect the nuclear option
if (length(args) == 0)
    args <- "auto"
opt$max <- as.numeric(opt$max)

chk <- length(args) <= 1   		# ask for argument check only on short argument vectoe

res <- incoming(args, chk, isFALSE(opt$skipsort), isTRUE(opt$ping), opt$max)

nr <- as.integer(opt$lines)
print(head(res, nr), nrows=nr)

#!/usr/bin/r

if (is.null(argv) | length(argv) < 1) {
    cat("Usage: silenceTwitterAccount.r user1 [user2 user3 ...]\n\n")
    cat("Calls rtweet::post_silence() for the given users.\n")
    cat("NB: Needs a modified version of rtweet and a twitter token.\n\n")
    q()
}

if (!requireNamespace("rtweet", quietly=TRUE))
    stop("Please install `rtweet`.", call. = FALSE)

if (Sys.getenv("TWITTER_PAT") == "")
    stop("Please setup a 'TWITTER_PAT' using `rtweet`.", call. = FALSE)

library(rtweet)
if (is.na(match("post_silence", ls("package:rtweet"))))
    stop("This needs a version of 'rtweet' with the post_silence() function", call. = FALSE)

for (arg in argv) rtweet::post_silence(arg)

#!/usr/bin/env r
#
# Aggregation of 'deadline' packages by maintainer -- simplistic as it does
# not further normalize the 'Maintainer' field
#
# Copyright (C) 2025  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

db <- as.data.frame(tools::CRAN_package_db())
dd <- with(db, db[!is.na(Deadline), c("Package", "Deadline", "Maintainer")])
bb <- aggregate(Package ~ Maintainer, dd, NROW)
bb <- with(bb, bb[Package > 1,])
bb <- with(bb, bb[order(-Package),])
print(bb, row.names=FALSE)

## Internal, not exported, function used by unit tests
test <- function(src = "cat(2 + 2)") {
    system2(r(), c("-e", shQuote(src)), stdout = TRUE, stderr = TRUE)
}


##' Return the path of the install \code{r} binary.
##'
##' The test for Windows is of course superfluous as we have no binary for Windows.
##' Maybe one day...
##' @title Return Path to \code{r} Binary
##' @param usecat Optional toggle to request output to stdout (useful in Makefiles)
##' @return The path is returned as character variable. If the \code{usecat} option is
##' set the character variable is displayed via \code{\link{cat}} instead.
##' @author Dirk Eddelbuettel
r <- function(usecat=FALSE) {
    p <- file.path(system.file(package="littler"),
                   "bin",
                   paste0("r", ifelse(.Platform$OS.type=="windows", ".exe", "")))
    if (usecat) return(cat(p)) # nocov
    p
}

#!/usr/bin/env -S r -t
##
##  Call 'rcmdcheck' on a package
##
##  Copyright (C) 2016 - 2024  Dirk Eddelbuettel
##
##  Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: rcc.r [-h] [-x] [-c] [-f] [-q] [-v] [--args ARGS] [--libpath LIBP] [--repos REPO] [--erroron ERRON] [PATH...]

-c --as-cran          should '--as-cran' be added to ARGS [default: FALSE]
-a --args ARGS        additional arguments to be passed to 'R CMD CHECK' [default: ]
-l --libpath LIBP     additional library path to be used by 'R CMD CHECK' [default: ]
-r --repos REPO       additional repositories to be used by 'R CMD CHECK' [default: ]
-f --fast             should vignettes and manuals be skipped [default: FALSE]
-v --valgrind         should tests run with 'valgrind' debug tool [default: FALSE]
-e --erroron ERRON    whether to throw an error on failure [default: never]
-q --quiet            should 'rcmdcheck' be called quietly [default: FALSE]
-h --help             show this help text
-x --usage            show help and short example usage"

opt <- docopt(doc)          # docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  rcc.r                        # check repo in current (working) director
  rcc.r -c                     # run as R CMD check --as-crn

rcc.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

erroron <- switch(opt$erroron,
                  never   = "never",
                  error   = "error",
                  warning = "warning",
                  note    = "note",
                  "badarg")
if (erroron=="badarg")
    stop("Inadmissable argument for '--erroron' option.", call.=FALSE)

if (is.null(opt$args)) {         # special treatment for --args and -c
    if (opt$as_cran) {
        opt$args <- "--as-cran"
    } else {
        opt$args <- character()
    }
} else {
    if (opt$as_cran) {
        opt$args <- c(opt$args, "--as-cran")
    }
}
if (opt$fast) {
    opt$args <- c(opt$args, "--ignore-vignettes", "--no-manual")
}
if (opt$valgrind) {
    opt$args <- c(opt$args, "--use-valgrind")
}

if (length(opt$PATH) == 0) opt$PATH <- "."      # default argument current directory
if (is.null(opt$libpath)) opt$libpath <- .libPaths()    # default library pathr
if (is.null(opt$repos)) opt$repos <- getOption("repos") # default repos

if (requireNamespace("rcmdcheck", quietly=TRUE) == FALSE)
    stop("This command requires the 'rcmdcheck' package.", call. = FALSE)

suppressMessages(library(rcmdcheck))

Sys.setenv("_R_CHECK_TESTS_NLINES_"="0")        # ensure all errors shown

rccwrapper <- function(pa, qu, ar, li, re, eo) {
    res <- rcmdcheck(path=pa, quiet=qu, args=ar,
                     build_args=c("--compact-vignettes=both", "--resave-data"),
                     libpath=li, repos=re, error_on=eo)
    print(res)
    res
}

rc <- sapply(opt$PATH,                  # iterate over arguments
             rccwrapper,                # calling 'rcmdcheck()' with arguments
             opt$quiet,                 # quiet argument, default false
             opt$args,                  # args arguments, possibly with --as-cran
             opt$libpath,               # libpath argument
             opt$repos,                 # repos argument
             erroron,                   # error_on argument
             simplify=FALSE)
status <- max(sapply(rc, "[[", "status"))
q(status=status)

#!/usr/bin/env r
#
# Simple helper script for roxygen2::roxygenize()
#
# Dirk Eddelbuettel, 2013 - 2020
#
# GPL-2 or later

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: roxy.r [-n] [-f] [-h] [-x] [-r ROCLETS] [PACKAGES ...]

-n --nocache          run the current version not the cached version
-r --roclets ROCLETS  use roclets arguments for roxygenize [default: rd]
-f --full             implies both '-n' and '-r NULL'
-h --help             show this help text
-x --usage            show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where PACKAGES... can be one or more packages.

Examples:
  roxy.r                     # update help pages for package, use cached version
  roxy.r -n                  # use non-cached version
  roxy.r -r NULL             # use full roclets i.e. collate,namespace,rd
  roxy.r -f                  # use non-cached version and 'NULL' roclets

roxy.r is part of littler which brings 'r' to the command-line. See the help for
roxygenize for the different 'roclets' arguments; default value 'rd' means to only
update Rd files.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (opt$full) {
    opt$nocache <- TRUE
    opt$roclets <- "NULL"
}

## Works around the marvel that is version 6.1.0 or later
if (!opt$nocache && dir.exists("~/.R/cache/roxygen2")) {
    cat("** Using cached version 6.0.1 of roxygen2.\n")
    .libPaths("~/.R/cache")
}

## load roxygen
library(roxygen2)

## check all command-line arguments (if any are given) for directory status
argv <- Filter(function(x) file.info(x)$is.dir, argv)

## loop over all argument, with fallback of the current directory, and
## call roxygenize() on the given directory with roclets="rd" set
sapply(ifelse(length(argv) > 0, argv, "."),
       FUN = roxygenize,
       roclets = if (tolower(opt$roclets) == "null") NULL else opt$roclets)

#!/usr/bin/env r
#
# An even simpler example to install dependencies
#
# Copyright (C) 2024 - present  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt and remotes (or devtools) from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

## configuration for docopt
doc <- "Usage: installDeps2.r [-h] [-x] [-s] [DESC]

-s --suggests     Add 'Suggests' to dependencies
-h --help         show this help text
-x --usage        show help and short example usage
"

opt <- docopt(doc)          # docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("

  installDeps2.r

The script expects a DESCRIPTION file in the local directory (or given as the
argument) which it then parses.

The basic mechanics of doing this dependency-free came from a Dockerfile at the
`data.table` repository, and are a appreciated. An alternative version, relying
on the `remotes` package, has been available for several years with littler as
`installDeps.r`.

installDeps2.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (length(opt$DESC)==0 && file.exists("DESCRIPTION") && file.exists("NAMESPACE")) {
    #message("* installing deps for found in current working directory ...")
    descfile <- "DESCRIPTION"
} else {
    descfile <- opt$DESC
}

flds <- c("Imports", "Depends", "LinkingTo")
if (opt$suggests) flds <- c(flds, "Suggests")

res <- read.dcf(descfile)[1,]               # we read only one file so first row only
res <- res[intersect(names(res), flds)]     # intersect available and desired fields
pkgs <- tools:::.split_dependencies(res)    # parse and split, then diff off base packages
instpkgs <- setdiff(names(pkgs), tools:::.get_standard_package_names()$base)
install.packages(instpkgs)                  # and install remainder

#!/usr/bin/env r
#
# A simple example to install from RSPM
#
# Copyright (C) 2020 - present  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

if (Sys.info()[["sysname"]] != "Linux")
    stop(paste("Currently only supported on Linux.",
               "Please get in touch if you want to / can help on macOS"), call.=FALSE)

code <- "<unknown>"
if (file.exists("/etc/os-release")) {   # next block borrowed from my chshli package on GitHub
    osrel <- read.table("/etc/os-release", sep="=", row.names=1, col.names=c("key","value"))
    if ("REDHAT_SUPPORT_PRODUCT" %in% rownames(osrel)) {
        # 'centos7' for CentOS/RHEL 7, 'centos8' for CentOS/RHEL 8 and Fedora
        ver <- osrel["REDHAT_SUPPORT_PRODUCT_VERSION", "value"]
        code <- paste0("centos", min(as.numeric(ver), 8))
    } else if ("VERSION_CODENAME" %in% rownames(osrel)) {
        code <- osrel["VERSION_CODENAME", "value"]
    }
}
if ((code == "<unknown>") && (Sys.which("lsb_release") != "")) {
    code <- system("lsb_release -c | awk '{print $2}'", intern=TRUE)
}

## configuration for docopt
doc <- paste0("Usage: installRSPM.r [-h] [-x] ARGS...

-c --code ARG    set code name for distribution [default: ", code, "]
-l --libloc ARG  location in which to install [default: ", .libPaths()[1], "]
-h --help        show this help text
-x --usage       show help and short example usage

Note that RSPM support is still somewhat experimental. There may not be binaries
for every possibly OS and distibution. Please file issue tickets at the Github
repo for littler if you can contribute additional checks and values.
")

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("

Basic usage:

  installRSPM.r digest

installRSPM.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (!is.null(opt$libloc)) .libPaths(opt$libloc)

r <- getOption("repos")
r["CRAN"] <- paste0("https://packagemanager.rstudio.com/all/__linux__/", code, "/latest")
options(repos = r)
options(HTTPUserAgent = sprintf("R/%s R (%s)", getRversion(),
                                paste(getRversion(), R.version$platform, R.version$arch, R.version$os)))

invisible(sapply(opt$ARGS, function(r) install.packages(r)))

#!/usr/bin/env r
#
# Simple helper script for roxygen2::roxygenize()
#
# Dirk Eddelbuettel, 2013 - 2020
#
# GPL-2 or later

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: roxy.r [-n] [-f] [-m] [-h] [-x] [-r ROCLETS] [PACKAGES ...]

-n --nocache          run the current version not the cached version
-r --roclets ROCLETS  use roclets arguments for roxygenize [default: rd]
-f --full             implies both '-n' and '-r NULL'
-m --minimal          implies 'namespace,rd' roclets
-l --libpath LIBP     additional library path to be added [default: ]
-h --help             show this help text
-x --usage            show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where PACKAGES... can be one or more packages.

Examples:
  roxy.r                     # update help pages for package, use cached version
  roxy.r -n                  # use non-cached version
  roxy.r -r NULL             # use full roclets i.e. collate,namespace,rd
  roxy.r -r 'namespace,rd'   # use specified roclets i.e. namespace,rd
  roxy.r -f                  # use non-cached version and 'NULL' roclets
  roxy.r -m                  # shorthand for use 'of namespace,rd' roclets

roxy.r is part of littler which brings 'r' to the command-line. See the help for
roxygenize for the different 'roclets' arguments; default value 'rd' means to only
update Rd files.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (opt$full) {
    opt$nocache <- TRUE
    opt$roclets <- "NULL"
}
if (opt$minimal) {
    opt$nocache <- FALSE
    opt$roclets <- "namespace,rd"
}

## Works around the marvel that is version 6.1.0 or later
if (!opt$nocache && dir.exists("~/.R/cache/roxygen2")) {
    cat("** Using cached version 6.0.1 of roxygen2.\n")
    .libPaths("~/.R/cache")
}

## load roxygen
library(roxygen2)

if (!is.null(opt$libpath)) .libPaths(opt$libpath)

## check all command-line arguments (if any are given) for directory status
argv <- Filter(function(x) file.info(x)$is.dir, argv)

## loop over all argument, with fallback of the current directory, and
## call roxygenize() on the given directory with roclets="rd" set
sapply(ifelse(length(argv) > 0, argv, "."),
       FUN = roxygenize,
       roclets = if (tolower(opt$roclets) == "null") NULL else strsplit(opt$roclets,",")[[1]])

#!/usr/bin/env r
#
# Minimal rhub::check_for_cran() wrapper
#
# Copyright (C) 2016 - 2020  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

checkargs <- "--no-manual --no-vignettes"
checkfile <- function(f) if (file.exists(f)) rhub::check_for_cran(f, check_args=checkargs)
if (length(argv) == 0) argv <- "."
sapply(argv, checkfile)

#!/usr/bin/env r
#
# Minimal 'Deadline' field printer from CRAN db
#
# Copyright (C) 2024 - 2026  Dirk Eddelbuettel
#
# Released under GPL (>= 2)
#
# Uses argv[1], if present, to provide column width else use heuristic

## borrowed with love from tinytest and marginally extended
.color_str <- function(x, color) {
    cmap <- c(cyan=36, red=31, green=32, blue=34, purple=35)
    sprintf("\033[0;%dm%s\033[0m", cmap[color], x)
}
.blue <- function(txt) .color_str(txt, "blue")
.purple <- function(txt) .color_str(txt, "purple")

db <- as.data.frame(tools::CRAN_package_db())
dd <- with(db, db[!is.na(Deadline), c("Package", "Version", "Deadline")])
dd <- with(dd, dd[order(Deadline, Package), ])

cols <- if (length(argv) >= 1) as.integer(argv[1]) else 1.44*getOption("width")
dts <- unique(dd[, "Deadline"])
for (d in seq_along(dts)) {
    cat(.blue(dts[d]), ": ", sep="")
    ind <- with(dd, Deadline == dts[d])
    blk <- dd[ind, ]
    pv <- paste0(.purple(blk[,1]), " (", blk[,2], ")")
    cat(paste(strwrap(paste(pv, collapse=", "), cols), "\n"))
}

#!/usr/bin/env r
#
# Simple helper script for compileAttributes()
#
# Dirk Eddelbuettel, July 2014
#
# GPL-2 or later

## load Rcpp
suppressMessages(library(Rcpp))

## check all command-line arguments (if any are given) for directory status
argv <- Filter(function(x) file.info(x)$is.dir, argv)

## loop over all argument, with fallback of the current directory, and
## call compileAttributes() on the given directory
sapply(ifelse(length(argv) > 0, argv, "."), compileAttributes)

#!/usr/bin/env r
#
# Simple r2u helper frontend
#
# Copyright (C) 2022 - 2026  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

library(docopt)

doc <- "Usage: r2u.r [--release DIST] [--debug] [--verbose] [--force] [--xvfb] [--bioc] [--suffix SUF] [--debver DBV] [--plusdfsg] [--uncache] [--dryrun] [--compile] [--help] CMD ...

Options:
-r --release DIST   release distribution to use, one of 'focal', 'jammy', 'noble', 'resolute' [default: noble]
-d --debug          boolean flag for extra debugging
-v --verbose        boolean flag for verbose operation
-f --force          boolean flag to force a build
-x --xvfb           boolean flag to build under 'xvfb' (x11 virtual framebuffer)
-b --bioc           boolean flag to update BioConductor (subset) not CRAN
-s --suffix SUF     build version suffix appended [default: .1]
-t --debver DBV     debian version leading digit [default: 1.]
-p --plusdfsg       boolean flag if upstream version gets '+dfsg'
-u --uncache        remove the cached meta data archives of available packages (when using 'build' or 'package' commands)
-n --dryrun         boolean flag for dry-run of skip build  (when using 'build' or 'package' commands)
-c --compile        boolean flag for ensuring a compilation from source
-h --help           show this help text

Commands:
build        updates all packages
last         reports most recent binary package sync
count        counts packages downloaded (locally) today
table        tabulates packages downloaded today
package      updates the package(s) named in ... and builds

Note that some of the status subcommand are somewhat dependent on auxiliary scripts on my machine.
"

opt <- docopt(doc)
if (!is.finite(match(opt$release, c("focal", "jammy", "noble", "resolute"))))
    stop("Unknown distro '", opt$release, "'.", call. = FALSE)

if (length(opt$CMD) > 1) {
    opt$args <- opt$CMD[-1]
    opt$CMD <- opt$CMD[1]
}

if (!is.finite(match(opt$CMD, c("build", "last", "count", "table", "package"))))
    stop("Unknown command '", opt$CMD, "'.", call. = FALSE)

if (is.finite(match(opt$CMD, "build"))) {
    library(r2u)
    if (opt$uncache) {
        for (db in c(r2u:::.defaultCRANDBFile(), r2u:::.defaultAPFile()))
            if (file.exists(db)) unlink(db)
        r2u:::.loadDB()
        r2u:::.loadAP()
    }
    buildUpdatedPackages(opt$release,
                         opt$debug,
                         opt$verbose,
                         opt$force,
                         opt$xvfb,
                         opt$bioc,
                         opt$dryrun)

} else if (is.finite(match(opt$CMD, "last"))) {
    # NB now dead too:  D <- RcppSimdJson::fload("https://p3m.dev/__api__/sources/1/transactions")
    #ts <- anytime::utctime(D[1,"completed"])
    #dh <- as.numeric(difftime(Sys.time(), ts, units="hours"))
    #un <- "days"
    #if (dh <= 3) un <- "mins" else if (dh < 25) un <- "hours"
    #cat("P3M/PPM/RSPM last updated", format(round(difftime(Sys.time(), ts, units=un),1)), "ago\n")
    ## no longer includes hours :-/
    #ld <- anytime::utcdate(D[1,"completed"])
    ## also:  hit given yyyy-mm-dd in eg https://packagemanager.posit.co/cran/2025-04-22/src/contrib/PACKAGES
    ##        and then check success / failure -- might be lighter than downloading the whole blob
    ld <- as.Date(max(RcppSimdJson::fload("https://p3m.dev/__api__/repos/cran/transaction-dates")$alias))
    cat("P3M/PPM/RSPM last updated", as.integer(Sys.Date()) - as.integer(ld), "days ago on", format(ld), "\n")

} else if (is.finite(match(opt$CMD, "count"))) {
    ll <- readLines(pipe("bash -c ~/bin/web_who_what | grep '.*cranapt\\/pool\\/dists\\/.*\\/r-.*\\.deb$'"))
    cat(length(ll), ".deb files downloaded\n")

} else if (is.finite(match(opt$CMD, "table"))) {
    con <- pipe("bash -c ~/bin/web_who_what | grep '.*cranapt\\/pool\\/dists\\/.*\\/r-.*\\.deb$'")
    ll <- readLines(con)
    close(con)
    tt <- table(gsub(".*r-(cran|bioc)-(.*)_\\d+.*", "\\2", ll, perl=TRUE))
    print(head(tt[order(-tt)], 10))

} else if (is.finite(match(opt$CMD, "package"))) {
    library(r2u)
    if (opt$uncache) {
        for (db in c(r2u:::.defaultCRANDBFile(), r2u:::.defaultAPFile()))
            if (file.exists(db)) unlink(db)
        r2u:::.loadDB()
        r2u:::.loadAP()
    }
    for (p in opt$args) {
        buildPackage(pkg     = p,
                     tgt     = opt$release,
                     debug   = opt$debug,
                     verbose = opt$verbose,
                     force   = opt$force,
                     xvfb    = opt$xvfb,
                     suffix  = opt$suffix,
                     debver  = opt$debver,
                     plusdfsg= opt$plusdfsg,
                     dryrun  = opt$dryrun,
                     compile = opt$compile)
    }
}

#!/usr/bin/env -S r -t
#
# tinytest wrapper
#
# Copyright (C) 2019 - 2024  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

if (!requireNamespace("tinytest", quietly=TRUE))
    stop("Please install 'tinytest' from CRAN.", call. = FALSE)

## load docopt and tinytest from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
    library(tinytest)             # or can use devtools as a fallback
})

## configuration for docopt
doc <- "Usage: tt.r [-h] [-x] [-a] [-b] [-c] [-d] [-f] [-n NCPUS] [-p] [-s] [-z] [ARG...]

-a --all            use test_all mode [default: FALSE]
-b --build          use build-install-test mode [default: FALSE]
-c --ci             set environment variable CI to TRUE [default: FALSE]
-d --directory      use directory mode [default: FALSE]
-f --file           use file mode [default: FALSE]
-n --ncpus NCPUS    use 'ncpus' in parallel [default: getOption]
-p --package        use package mode [default: FALSE]
-s --silent         use silent and do not print result [default: FALSE]
-z --effects        show side effects [default: FALSE]
-h --help           show this help text
-x --usage          show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where ARG... can be one or more file name, or directories or package names.

Examples:
  tt.r -a                             # test 'all files' from current directory
  tt.r -f testfile.R                  # test the file 'testfile.R'
  tt.r -d testdir                     # test all files in the directory 'testdir'
  tt.r -p testpkg                     # test the (installed) package 'testpkg'
  tt.r -n 1 -p testpkg                # test (installed) package 'testpkg' in serial mode
  tt.r                                # run test_all() if DESCRIPTION && inst/tinytest/

tt.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

sideeffects <- if (opt$effects) TRUE else FALSE		# by default, do not show side effects

if (opt$ncpus == "getOption") {
    opt$ncpus <- getOption("Ncpus", 1L)
} else if (opt$ncpus == "-1") {
    ## parallel comes with R 2.14+
    opt$ncpus <- max(1L, parallel::detectCores())
} else {
    opt$ncpus <- as.integer(opt$ncpus)
}

if (opt$ci) {
    Sys.setenv(CI="TRUE")
}

res <- NULL
if (opt$all) {
    res <- test_all(if (length(opt$ARG) == 0) "." else opt$ARG, side_effects=sideeffects)
} else if (opt$build) {
    res <- build_install_test(if (length(opt$ARG) == 0) "." else opt$ARG, side_effects=sideeffects, ncpu=opt$ncpus)
} else if (opt$file) {
    res <- run_test_file(opt$ARG, side_effects=sideeffects)
} else if (opt$directory) {
    if (length(opt$ARG) == 0 && dir.exists("inst/tinytest")) opt$ARG <- "inst/tinytest"
    res <- run_test_dir(opt$ARG, side_effects=sideeffects)
} else if (opt$package) {
    if (opt$ncpus == 1L) {
        res <- test_package(opt$ARG, side_effects=sideeffects)
    } else {
        res <- test_package(opt$ARG, side_effects=sideeffects, ncpu=opt$ncpus)
    }
} else if (file.exists("DESCRIPTION") && dir.exists("inst/tinytest")) {
    res <- test_all(".", side_effects=sideeffects)
}

if (!opt$silent && !is.null(res)) print(res)

#!/usr/bin/env r 
#
# a simple example to convert miles and times into a pace
# where the convention is that we write e.g. 37 min 15 secs
# as 37.15 -- so a call 'pace.r 4.5 37.15' yields a pace of
# 8.1667, ie 8 mins 16.67 secs per mile
#
# Copyright (C) 2006 - 2014  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

if (is.null(argv) | length(argv)!=2) {

  cat("Usage: pace.r miles time\n")
  q()

}

dig <- 5
  
rundist <- as.numeric(argv[1])
runtime <- as.numeric(argv[2])

cat("Miles   : ", format(rundist, digits=dig), "\n")
cat("Time    : ", format(runtime, digits=dig), "\n")

totalseconds <- floor(runtime)*60 + (runtime-floor(runtime))*100
totalsecondspermile <- totalseconds / rundist
minutespermile <- floor(totalsecondspermile/60)
secondspermile <- totalsecondspermile - minutespermile*60

pace <- minutespermile + secondspermile/100

cat("Pace    : ",
    format(minutespermile, digits=1), "min",
    format(secondspermile, digits=dig), "sec\n")

cat("Mph     : ",
	format( (rundist * 3600)/totalseconds, digits=dig),"\n")

#!/usr/bin/env r
#
# A installer for r-universe binaries (on Ubuntu 'noble' only)
#
# Copyright (C) 2023-current  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)
library(utils) 		# for osVersion

rver <- gsub("^([\\d].[\\d]).*$", "\\1", as.character(getRversion()), perl=TRUE)
uburel <- "noble"
## configuration for docopt
doc <- paste0("Usage: installRub.r [-h] [-x] [-k] [-m] [-d] [-c] [-r REL] [-v VER] [-u UNIV] [PACKAGES]

-u --universe UNIV  required argument specifying universe [default: ]
-v --version VER    R 'major.minor' version release pair to install for [default: ", rver, "]
-r --release REL    Ubuntu LTS release to install to install for [default: ", uburel, "]
-k --keepoption     so not set option 'bspm.version.check' to 'TRUE' as is default
-m --minimal        use a minimal repos vector i.e. do not add CRAN repo
-d --disable        disable 'bspm' if set which can help with packages also on CRAN
-c --multiverse     use 'r-multiverse' instead of 'r-universe' (may need '-u community')
-h --help           show this help text
-x --usage          show help and short example usage.

PACKAGES can also be a shorthand 'package@universe'. See '-x | --usage' for more.")
opt <- docopt(doc)			# docopt parsing
if (opt$usage) {
    cat(doc, "\n\n")
    cat("In general, PACKAGES... can be one or more R package names available in then selected
r-universe repository; its CRAN (as well as some core BioConductor) dependencies will be
provided automatically by r2u. It can also be a shorthand 'package@universe'.

Note that while CRAN works extremely hard to always provide an installable set of working
packages, r-universe works under a different model and its packages cannot offer any such
guarantees. Also note that while we use 'r2u' for the CRAN (and, to some extend, BioConductor)
parts full-filling *all* dependencies completely, the binaries from r-universe do not carry
any (system-)dependency info so you may end up with missing libries you may need to add. Where
an r-universe package exists on CRAN you can cover your ground by first installing the CRAN
version and then the r-universe version.

Also note that 'community.r-multiverse.org' is also aliased to 'r-multiverse.r-universe.dev'.

Examples:
  installRub.r -u rcppcore Rcpp RcppArmadillo     # installs (never than CRAN / r2u) Rcpp(Armadillo)
  installRub.r -u eddelbuettel RcppKalman         # installs non-CRAN package RcppKalman
  installRub.r rcpp@rcppcore                      # alternate to install Rcpp from RcppCore universe
  installRub.r polars@rpolars                     # alternate to install polars from rpolars universe
  installRub.r -u community -c polars             # install polars from (stable) community multiverse

installRub.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}
if (length(opt$PACKAGES) == 0) cat(doc, "\n")
if (getRversion() < "4.2.0") stop("R version 4.2.0 or later is required.", call. = FALSE)
if (!exists("osVersion") || is.null(utils::osVersion)) stop("Cannot find 'osVersion'. Weird.", call. = FALSE)
if (!startsWith(utils::osVersion, "Ubuntu")) stop("Ubuntu is required as host system.", call. = FALSE)
has_bspm <- requireNamespace("bspm", quietly=TRUE)
if (!opt$minimal && !has_bspm) stop("The 'bspm' package is required.", call. = FALSE)

if (is.null(opt$universe) && length(opt$PACKAGES) == 1) {
    tokens <- strsplit(opt$PACKAGES, "@")[[1]]
    opt$PACKAGES <- tokens[1]
    opt$universe <- tokens[2]
}

univ <- paste0("https://", opt$universe, ".",
               if (opt$multiverse) "r-multiverse.org" else "r-universe.dev",
               "/bin/linux/", opt$release, "-", R.version$arch, "/", opt$version)

if (!opt$keepoption) options(bspm.version.check=TRUE)

rep <- c("univ"=univ)
if (!opt$minimal) rep <- c(rep, cran=getOption("repos"))

if (opt$disable && has_bspm) bspm::disable()

install.packages(pkgs = opt$PACKAGES, repos = rep)

#!/usr/bin/env r
#
# A simple example to invoke unit tests
#
# Copyright (C) 2014 - 2017  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

suppressMessages({
    library(docopt)       # we need the docopt package
    library(RUnit)        # we need the RUnit package
})

doc <- "Usage: runit.r [-p PACKAGES] [--help] [FILES ...]

-p --packages PACKAGES      comma-separated list of packages to install [default: ]
-h --help                   show this help text"

opt <- docopt(doc)

for (p in strsplit(opt$packages, ",")[[1]])
    suppressMessages(require(p, character.only=TRUE))

for (f in opt$FILES)
    runTestFile(f)

q(status=0)

#!/usr/bin/env r
#
# Another example to convert from Rnw and also compact
#
# Copyright (C) 2019  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: sweave.r [-c] [-h] [-x] [FILES...]

-c --compact         compact pdf file [default: FALSE]
-h --help            show this help text
-x --usage           show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  sweave.r foo.Rnw bar.Rnw        # convert two given files

sweave.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

## helper function
sweaveFunction <- function(p) {
    if (!file.exists(p)) stop("No file '", p, "' found. Aborting.", call.=FALSE)
    utils::Sweave(p)
    s <- gsub(".Rnw$", ".tex", p)
    tools::texi2pdf(s, texi2dvi="pdflatex")
    tools::texi2pdf(s, texi2dvi="pdflatex")
    if (opt$compact) {
        r <- gsub(".Rnw$", ".pdf", p)
        if (file.exists(r)) tools::compactPDF(r, gs_quality="ebook")
    }
}

## render files using helper function
sapply(opt$FILES, sweaveFunction)

#!/usr/bin/env r
#
# Another example to install one or more (source) packages into a drat
#
# Copyright (C) 2015 - 2017  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
    library(drat)
})

## configuration for docopt
doc <- "Usage: drat.r [-h] [-x] [--repo REPO] [--commit MSG] [TARGZ...]

-r --repo REPO        repository path to use [default: ~/git/drat]
-c --commit MSG       in github use, commit with MSG (default: no commit)
-h --help             show this help text
-x --usage            show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  dratInsert.r myPkg_1.2-3.tar.gz              # installs into default (git) repo
  dratInsert.r -r /srv/R/  myPkg_1.2-3.tar.gz  # installs into local directory repo

dratInsert.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (is.null(opt$commit)) opt$commit <- FALSE

## helper function
installArg <- function(p, repo, commit) {
    if (!file.exists(p)) stop("No file '", p, "' found. Aborting.", call.=FALSE)
    insertPackage(p, repo, commit)
}

## insert packages using helper function
sapply(opt$TARGZ, installArg, opt$repo, opt$commit)

#!/usr/bin/env r
#
# A simple wrapper for tools::compactPDF
#
# Copyright (C) 2019  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: compactpdf.r [-h] [-x] [PATH...]

-h --help            show this help text
-x --usage           show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  compactpdf.r                        # compact in current directory

compactpdf.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (length(opt$PATH) == 0) {
    opt$PATH <- list.files(".", pattern=".pdf$")
}

compactFunction <- function(f) {
    tools::compactPDF(f, gs_quality="ebook")
}

sapply(opt$PATH, compactFunction)

#!/usr/bin/env r
#
# A simple example to install RStudio Desktop
#
# Copyright (C) 2014 - 2023  Carl Boettiger and Dirk Eddelbuettel
#
# Released under GPL (>= 2)
#
# based on earlier https://raw.githubusercontent.com/rocker-org/rstudio-daily/master/latest.R
#
# todo: cmdline options for different download options / distro flavours

setwd("/tmp")                           # go to /tmp
url <- "https://dailies.rstudio.com/rstudio/latest/index.json"
js <- jsonlite::fromJSON(url)
fileurl <- js$products$server$platforms$`jammy-amd64`$link
cat("'", url, "' -> '", file, "'\n", sep="")
download.file(fileurl, file) #, method="wget")

#!/usr/bin/env r
#
# A downloader for Pandoc's amd64 .deb
#
# Copyright (C) 2021  Dirk Eddelbuettel
#
# Released under GPL (>= 2)
#
# TODO: Maybe make the .deb filter an option

library(RcppSimdJson)

url <- "https://api.github.com/repos/jgm/pandoc/releases/latest"
res <- RcppSimdJson::fload(url)
files <- res$assets[, "browser_download_url"]
deb <- files[grepl("-amd64\\.deb$", files)]
tgt <- file.path("/tmp", basename(deb))
download.file(deb, tgt, quiet=TRUE)
cat("Downloaded '", deb, "' as '", tgt, "'\n", sep="")

## These tests were suggested by a user on OS X (in 2015), and then
## promptly failed on OS X per CRAN -- so we now make this conditional
## on Linux where it is known to work
##
## Until it doesn't as it appears to (in 2020) fail on Travis CI

if (unname(Sys.info()["sysname"]) == "Linux" && Sys.getenv("TRAVIS", "false") != "true") {
    library(littler)
    stopifnot(identical(littler:::test(), "4"))   # default test is cat(2+2)
    stopifnot(as.numeric(littler:::test('cat(R.version$year)')) >= 2015)  
}

#!/usr/bin/env r
#
# A simple example to install RStudio Desktop
#
# Copyright (C) 2014 - 2021  Carl Boettiger and Dirk Eddelbuettel
#
# Released under GPL (>= 2)
#
# based on earlier https://raw.githubusercontent.com/rocker-org/rstudio-daily/master/latest.R
#
# todo: cmdline options for different download options

#suppressMessages(library(rvest))

setwd("/tmp")                           # go to /tmp

#url <- "https://dailies.rstudio.com/rstudioserver/oss/ubuntu/amd64/"
#url <- "https://dailies.rstudio.com/rstudioserver/oss/ubuntu/x86_64/"
url <- "https://dailies.rstudio.com/rstudio/latest/index.json"
#pg <- read_html(url(url))
#tb <- html_table(html_nodes(pg, "table"))[[1]]
js <- jsonlite::fromJSON(url)
#file <- tb[[1,1]]
#s3url <- "https://s3.amazonaws.com/rstudio-ide-build/server/bionic/amd64/"
#s3url <- "https://s3.amazonaws.com/rstudio-ide-build/server%2Fbionic%2Famd64%2F"
#fileurl <- paste0(s3url, file)
#fileurl <- paste0(s3url, gsub("\\+","%2B", file))
#cat("'", fileurl, "' -> '", file, "'\n", sep="")
fileurl <- js$products$server$platforms$bionic$link
file <- basename(fileurl)
cat("'", url, "' -> '", file, "'\n", sep="")
download.file(fileurl, file) #, method="wget")

## possibly simpler
## cf https://support.rstudio.com/hc/en-us/articles/203842428-Getting-the-newest-RStudio-builds
## fileurl <- "https://www.rstudio.org/download/latest/stable/server/ubuntu64/rstudio-server-latest-amd64.deb"
#download.file(fileurl, "rstudio-server-latest-amd64.deb", method="wget")

#!/usr/bin/env r
#
# Install a package from BioConductor
#
# Copyright (C) 2020 - 2022  Dirk Eddelbuettel
# Copyright (C) 2022 - 2022  Dirk Eddelbuettel and Pieter Moris
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## default to first library location in .libPaths()
libloc <- .libPaths()[1]

## configuration for docopt
doc <- paste0("Usage: installBioc.r [-l LIBLOC] [-d DEPS] [-n NCPUS] [-r REPO ...] [--error] [--skipinstalled] [-m METHOD] [--force] [--update] [-h] [-x] [PACKAGES ...]
-l --libloc LIBLOC  location in which to install [default: ", libloc, "]
-d --deps DEPS      install suggested dependencies as well [default: NA]
-n --ncpus NCPUS    number of processes to use for parallel install [default: getOption]
-r --repo REPO      additional repository to use [default: getOption]
-e --error          throw error and halt instead of a warning [default: FALSE]
-s --skipinstalled  skip installing already installed packages (takes priority over --force) [default: FALSE]
-m --method METHOD  method to be used for downloading files [default: auto]
-f --force          force re-download of packages that are currently up-to-date [default: FALSE]
-u --update         update old already installed packages [default: FALSE]
-h --help           show this help text
-x --usage          show help and short example usage")
opt <- docopt(doc)  # docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where PACKAGES... can be one or more BioConductor names. Functionality depends on
package 'BiocManger' which has be installed.

Examples:
  installBioc.r -l /tmp/lib S4Vectors               # install into given library
  installBioc.r --update Biobase                    # install package and update older packages
  installBioc.r --deps NA --error --skipinstalled   # install package without suggested dependencies,
                                                    # throw an error on installation failure and skip
                                                    # packages that are already present

installBioC.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (!requireNamespace("BiocManager", quietly=TRUE)) {
    stop("Please install 'BiocManager' first, for example via 'install.r BiocManager'.", call.=FALSE)
}

## set repository to empty character vector if not supplied, since
## this is the input expected by BiocManager::install(site_repository=)
## (does not accept NA)
## the custom repository must be a sub-repository of a main BioC_mirror
## e.g. software: https://bioconductor.statistik.tu-dortmund.de/packages/3.15/bioc/
## annotation: https://ftp.gwdg.de/pub/misc/bioconductor/packages/3.14/data/annotation
if (opt$repo == "getOption") {
    opt$repo = character()
}

## check if dependencies need to be installed, see
## https://www.rdocumentation.org/packages/utils/versions/3.6.2/topics/install.packages
## the default, NA, means c("Depends", "Imports", "LinkingTo"), but not "Suggests"
if (opt$deps == "TRUE" || opt$deps == "FALSE") {
    opt$deps <- as.logical(opt$deps)
} else if (opt$deps == "NA") {
    opt$deps <- NA
}

## set the number of parallel processes to use for a parallel install of
## more than one source package, see
## https://www.rdocumentation.org/packages/utils/versions/3.6.2/topics/install.packages
if (opt$ncpus == "getOption") {
    opt$ncpus <- getOption("Ncpus", 1L)
} else if (opt$ncpus == "-1") {
    ## parallel comes with R 2.14+
    opt$ncpus <- max(1L, parallel::detectCores())
}

## helper function to catch errors that could arise when package installation has failed
## and to skip installation of packages that are already present (for BiocManager::install()
## these would otherwise result in additional warnings)
install_bioc <- function(pkgs, ..., error = FALSE, skipinstalled = FALSE) {
    e <- NULL
    capture <- function(e) {
        if (error) {
            catch <-
                grepl("installation of .* packages failed", e$message) ||
                grepl("is not available", e$message) ||
                grepl("had non-zero exit status", e$message) ||
                grepl("compilation failed for package.*", e$message) ||
                grepl("fatal error", e$message) ||
                grepl("No such file or directory", e$message)
            if (catch) {
                e <<- e
            }
        }
    }
    if (skipinstalled) {
        pkgs <- setdiff(pkgs, installed.packages()[,1])
    }
    if (length(pkgs) > 0) {
        withCallingHandlers(BiocManager::install(pkgs, ...), warning = capture)
        if (!is.null(e)) {
            stop(e$message, call. = FALSE)
        }
    }
}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

## install requested packages using helper function
## ask must be set to FALSE because user prompts do not appear when calling
## R from the CLI, e.g.
## `R -e 'BiocManager::install("Biobase", ask=TRUE, update=TRUE)'`
## might warn that MASS is out of date, but would not show a user prompt
install_bioc(pkgs = opt$PACKAGES,
        lib = opt$libloc,
        site_repository = opt$repo,
        update = opt$update,
        ask = FALSE,
        force = opt$force,
        dependencies = opt$deps,
        Ncpus = opt$ncpus,
        method = opt$method,
        error = opt$error,
        skipinstalled = opt$skipinstalled)

#!/usr/bin/env r
#
# A simple wrapper for toBibtex
#
# Copyright (C) 2019  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: pkg2bibtex.r [-h] [-x] [PKG...]

-h --help            show this help text
-x --usage           show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  pkg2bibtex.r anytime nanotime       # create two bibtex records

pkg2bibtex.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (length(opt$PATH) == 0) {
    opt$PATH <- "."
}

res <- sapply(opt$PKG, function(p) toBibtex(citation(p, auto=TRUE)), simplify=FALSE)
print(res)

#!/usr/bin/env r
#
# Convert NEWS.Rd to markdown
#
# Copyright (C) 2016 - 2017  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)
library(tools)

## configuration for docopt
doc <- "Usage: rd2md.r [-h] [-x] [--src REPODIR] [--out OUTDIR] [FILES...]

-s --src REPODIR      source root directory [default: ~/git]
-o --out OUTDIR       output directory [default: /tmp]
-h --help             show this help text
-x --usage            show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  rd2md.r foo                                  # implies conversion of ~/git/foo/inst/NEWS.Rd
  rd2md.r ~/git/foo/inst/NEWS.Rd               # converts given file to markdown

rd2md.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

## helper function
convertArg <- function(p, src, out) {
    filename <- mdfile <- NULL
    if (file.exists(p)) {
        filename <- p
        mdfile <- paste0(filename, ".md")
    } else {
        filename <- file.path(src, p, "inst", "NEWS.Rd")
        if (!file.exists(filename)) {
            stop("No matching file found for", p, call.=FALSE)
        }
        mdfile <- file.path(out, paste0(p, ".news.md"))
    }
    htmlfile <- paste0(filename, ".html")
    Rd2HTML(filename, htmlfile)
    cmd <- paste("pandoc", htmlfile, "-o", mdfile)
    system(cmd)
    unlink(htmlfile)
    cat("Converted", filename, "into", mdfile, "\n")
}

## insert packages using helper function
sapply(opt$FILES, convertArg, opt$src, opt$out)

#!/usr/bin/env r
#
# A simple example to invoke Sweave
#
# Copyright (C) 2014  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## use given argument(s) as target files, or else default to .Rnw files in directory
files <- if (length(argv) == 0) dir(pattern="*.Rnw") else argv <- Filter(function(x) file.info(x)$is.dir, argv)


## convert all files from Rnw to pdf using the highlight driver
invisible(sapply(files, function(srcfile) {
    Sweave(srcfile, driver=highlight::HighlightWeaveLatex(boxes=TRUE))
    tools::texi2pdf(gsub(".Rnw", ".tex", srcfile))
    tools::texi2pdf(gsub(".Rnw", ".tex", srcfile), texi2dvi="pdflatex")
}))

#!/usr/bin/env r
#
# Simple helper script for knitr
#
# Dirk Eddelbuettel, May 2013
#
# GPL-2 or later

if (is.null(argv)) {
    cat("Need an argument FILE.Rnw\n")
    q(status=-1)
}


file <- argv[1]
if (!file.exists(file)) {
    cat("File not found: ", file, "\n")
    q(status=-1)
}

require(knitr)
knit2pdf(file)

#!/usr/bin/env r
#
# A simple example to install one or more packages from GitHub
#
# Copyright (C) 2014 - 2020  Carl Boettiger and Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt and remotes (or devtools) from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
    library(remotes)              # or can use devtools as a fallback
})

## configuration for docopt
doc <- "Usage: installGithub.r [-h] [-x] [-d DEPS] [-u UPDATE] [-r REPOS...] [GHREPOS...]

-d --deps DEPS       install suggested dependencies as well? [default: NA]
-u --update UPDATE   update dependencies? [default: TRUE]
-r --repos REPOS     repositor(y|ies) to use if deps required [default: getOption]
-h --help            show this help text
-x --usage           show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where GHREPOS... is one or more GitHub repositories.

Basic usage:

  installGithub.r RcppCore/RcppEigen

Install multiple R packages from GitHub:

  installGithub.r RcppCore/Rcpp RcppCore/RcppEigen

Install multiple R packages from GitHub listing the packages on separate lines with some comments:

  installGithub.r \\
    RcppCore/Rcpp \\
    RcppCore/RcppEigen

Installing a specific branch, tag or commit:

  installGithub.r RcppCore/Rcpp@1.0.0

Setting multiple R package repositories to install dependencies of the R package:

  installGithub.r -r https://cloud.r-project.org -r https://eddelbuettel.github.io/drat RcppCore/RcppEigen

installGithub.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

if (opt$deps == "TRUE" || opt$deps == "FALSE") {
    opt$deps <- as.logical(opt$deps)
} else if (opt$deps == "NA") {
    opt$deps <- NA
}

if (length(opt$repos) == 1 && opt$repos == "getOption") {
    ## as littler can now read ~/.littler.r and/or /etc/littler.r we can preset elsewhere
    opt$repos <- getOption("repos")
}

opt$update <- as.logical(opt$update)

invisible(sapply(opt$GHREPOS, function(r) install_github(r, dependencies = opt$deps, upgrade = opt$update, repos = opt$repos)))

#!/usr/bin/env r
#
# A simple example to install from RSPM
#
# Copyright (C) 2020 - present  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

if (Sys.info()[["sysname"]] != "Linux")
    stop(paste("Currently only supported on Linux.",
               "Please get in touch if you want to / can help on macOS"), call.=FALSE)

if (!requireNamespace("bspm", quietly=TRUE))
    stop("The 'bspm' package is required. Please install it.", call.=FALSE)

## configuration for docopt
doc <- paste0("Usage: installBSPM.r [-h] [-x] ARGS...
-h --help        show this help text
-x --usage       show help and short example usage

Note that BSPM support is still somewhat experimental. It also requires support
(via the 'bspm' package) of the underlying system package manager, which is known to
work for apt/dpkg (Debian, Ubuntu, ...) and dnf/yum (Fedora/RH/CentOS). Please file
issue tickets at the Github repo for littler (or bspm) if you can help with additional
settings.

Note that to take fullest advantage of BSPM, you also need the system package manager to
know about the largest number of pre-compiled packages. For Ubuntu, this means the
exanded 'ppa:c2d4u.team/c2d4u4.0+' repo, and for Fedora the say 'iucar/cran' Copr archive.
This user-level script does not attempt to later your system-level repository information.
")

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("

Basic usage:

  installBSPM.r digest

installBSPM.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

library(bspm)
bspm::enable()
options(bspm.sudo=TRUE)

install.packages(opt$ARGS)

#!/usr/bin/env r
#
# A simple example to install one or more packages from GitHub
#
# Copyright (C) 2014 - 2026  Carl Boettiger and Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt and remotes (or devtools) from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
    library(remotes)              # or can use devtools as a fallback
})

## configuration for docopt
doc <- "Usage: installGithub.r [-h] [-x] [-d DEPS] [-u UPDATE] [-r REPOS...] [-t TYPE] [GHREPOS...]

-d --deps DEPS       install suggested dependencies as well? [default: NA]
-u --update UPDATE   update dependencies? [default: TRUE]
-r --repos REPOS     repositor(y|ies) to use if deps required [default: getOption]
-t --type TYPE       installation type as used by `install.packages` [default: source]
-h --help            show this help text
-x --usage           show help and short example usage

Note that if `bspm` is seen and option `bspm.version.check` is `FALSE` the `type` option is
switched to `both` to permit `bspm` to install e.g. build-dependencies as r2u binaries."

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where GHREPOS... is one or more GitHub repositories.

Basic usage:

  installGithub.r RcppCore/RcppEigen

Install multiple R packages from GitHub:

  installGithub.r RcppCore/Rcpp RcppCore/RcppEigen

Install multiple R packages from GitHub listing the packages on separate lines with some comments:

  installGithub.r \\
    RcppCore/Rcpp \\
    RcppCore/RcppEigen

Installing a specific branch, tag or commit:

  installGithub.r RcppCore/Rcpp@1.0.0

Installing from a repo subdirectory:

  installGithub.r chanzuckerberg/cellxgene-census/api/r/cellxgene.census

Setting multiple R package repositories to install dependencies of the R package:

  installGithub.r -r https://cloud.r-project.org -r https://eddelbuettel.github.io/drat RcppCore/RcppEigen

installGithub.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

if (opt$deps == "TRUE" || opt$deps == "FALSE") {
    opt$deps <- as.logical(opt$deps)
} else if (opt$deps == "NA") {
    opt$deps <- NA
}

if (length(opt$repos) == 1 && opt$repos == "getOption") {
    ## as littler can now read ~/.littler.r and/or /etc/littler.r we can preset elsewhere
    opt$repos <- getOption("repos")
}

if (requireNamespace("bspm", quietly=TRUE) & isFALSE(getOption("bspm.version.check", TRUE))) {
    ## when bspm is installed and set to prefer binaries, select type both
    opt$type <- "both"
}

opt$update <- as.logical(opt$update)

invisible(sapply(opt$GHREPOS, function(r) install_github(r, dependencies = opt$deps, upgrade = opt$update, repos = opt$repos, type = opt$type)))

#!/usr/bin/env r
#
# Install a package from BioConductor
#
# Copyright (C) 2020 -       Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: installBioc.r [-l LIBLOC] [-h] [-x] [PACKAGES ...]

-l --libloc LIBLOC  location in which to install [default: /usr/local/lib/R/site-library]
-h --help           show this help text
-x --usage          show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where PACKAGES... can be one or more BioConductor names. Functionality depends on
package 'BiocManger' which has be installed.

Examples:
  installBioc.r -l /tmp/lib S4Vectors               # install into given library

installBioC.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (!requireNamespace("BiocManager", quietly=TRUE)) {
    stop("Please install 'BiocManager' first, for example via 'install.r BiocManager'.", call.=FALSE)
}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

## set .libPaths()
.libPaths(opt$lib)

BiocManager::install(opt$PACKAGES, update=FALSE, ask=FALSE)

#!/usr/bin/env r
#
# A downloader for Quarto
#
# Copyright (C) 2021  Dirk Eddelbuettel
#
# Released under GPL (>= 2)
#
# TODO: Maybe make the .deb filter an option

library(RcppSimdJson)

url <- "https://api.github.com/repos/quarto-dev/quarto-cli/releases/latest"
res <- RcppSimdJson::fload(url)
files <- res$assets[, "browser_download_url"]
deb <- files[grepl("\\.deb$", files)]
tgt <- file.path("/tmp", basename(deb))
download.file(deb, tgt, quiet=TRUE)
cat("Downloaded '", deb, "' as '", tgt, "'\n", sep="")

#!/usr/bin/env r

# This should dynamically load stats
cat("Is stats loaded?\n");

cat("search: ",search(),"\n");
if(!("package:stats" %in% search())){
	cat("Nope!\n");
}

cat("Calling ts(1:10)\n");

cat(ts(1:10),"\n");

cat("Now stats is loaded!\n");
cat("search: ",search(),"\n");


if(!("package:utils" %in% search())){
	cat("No utils!\n");
	cat("Calling timestamp()\n");
	cat(timestamp(),"\n");
	cat("search: ",search(),"\n");
}

#!/usr/bin/env r
#
# Minimal rhub(".", platform="solaris-x86-patched")
#
# Copyright (C) 2016 - 2020  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

#checkargs <- "--no-manual --no-vignettes"
solaris <- "solaris-x86-patched"
checkfile <- function(f) if (file.exists(f)) rhub::check(f, platform=solaris)#, check_args=checkargs)
if (length(argv) == 0) argv <- "."
sapply(argv, checkfile)

#!/usr/bin/env r
#
# A simple example to check the incoming queue at CRAN
#
# Copyright (C) 2020 - present  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

if (!requireNamespace("foghorn", quietly=TRUE))
    stop("The 'foghorn' is required. Please install it.", call.=FALSE)

## configuration for docopt
doc <- paste0("Usage: cranIncoming.r [-a] [-h] [-x] [ARGS...]
-a --all         show everything in incoming
-h --help        show this help text
-x --usage       show help and short example usage
")

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("

Basic usage:

  cranIncoming.r digest binb

cranIncoming.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (length(opt$ARGS) == 0) opt$ARGS <- if (opt$all) NULL else character()
print(data.frame(foghorn::cran_incoming(opt$ARGS)), row.names=FALSE)

#!/usr/bin/env r
##
##  A simple example to builds a source tar.gz file
##
##  Copyright (C) 2017 - 2019  Dirk Eddelbuettel
##
##  Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

doc <- "Usage: build.r [-f] [-h] [PACKAGES ...]

-f --fast      skip building vignettes and manual
-h --help      show this help text

Simple wrapper to 'R CMD build ...' which
calls 'tools:::.build_packages()' just like
the 'R CMD build' invocation.
"

opt <- docopt(doc)

if (length(opt$PACKAGES) == 0) opt$PACKAGES <- "." 	# default argument current directory

argv <- if (opt$fast) c("--no-build-vignettes", "--no-manual", opt$PACKAGES) else opt$PACKAGES

extraargs <- c("--compact-vignettes", "--resave-data", argv)

tools:::.build_packages(extraargs, no.q=interactive())

#!/usr/bin/env r
#
# A simple example to install dependencies
#
# Copyright (C) 2020 - present  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt and remotes (or devtools) from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
    library(remotes)              # or can use devtools as a fallback
})

## configuration for docopt
doc <- "Usage: installDeps.r [-h] [-x] [-s] [-d DEPS] [ARGS]

-d --deps DEPS    Logical or char, see '?install.packages', use 'TRUE' for all, [default: NA]
-s --suggests     Add 'Suggests' to dependencies, shortcut for '--deps TRUE'
-h --help         show this help text
-x --usage        show help and short example usage
"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("

Basic usage:

  installDeps.r .
  installDeps.r somePackage_1.2.3.tar.gz

The argument to '--deps' can be a combinations of 'Depends', 'Imports', 'LinkingTo',
'Suggests', and 'Enhances'. Default of 'NA' means first three, 'TRUE' means the first
four.

installDeps.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (length(opt$ARGS)==0 && file.exists("DESCRIPTION") && file.exists("NAMESPACE")) {
    ## we are in a source directory, so build it
    message("* installing deps for *source* package found in current working directory ...")
    opt$ARGS <- "."
}

if (opt$deps == "TRUE") opt$deps <- TRUE
if (opt$deps == "NA") opt$deps <- NA
if (opt$suggests) opt$deps <- TRUE

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

invisible(sapply(opt$ARGS, function(r) install_deps(r, dependencies=opt$deps)))

#!/usr/bin/env r
#
# tinytest wrapper
#
# Copyright (C) 2019 - 2020  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

if (!requireNamespace("tinytest", quietly=TRUE))
    stop("Please install 'tinytest' from CRAN.", call. = FALSE)

## load docopt and tinytest from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
    library(tinytest)             # or can use devtools as a fallback
})

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: tt.r [-h] [-x] [-a] [-b] [-d] [-f] [-n NCPUS] [-p] [-s] [-z] [ARG...]

-a --all            use test_all mode [default: FALSE]
-b --build          use build-install-test mode [default: FALSE]
-d --directory      use directory mode [default: FALSE]
-f --file           use file mode [default: FALSE]
-n --ncpus NCPUS    use 'ncpus' in parallel [default: getOption]
-p --package        use package mode [default: FALSE]
-s --silent         use silent and do not print result [default: FALSE]
-z --effects        suppress side effects [default: FALSE]
-h --help           show this help text
-x --usage          show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where ARG... can be one or more file name, or directories or package names.

Examples:
  tt.r -a                             # test 'all files' from current directory
  tt.r -f testfile.R                  # test the file 'testfile.R'
  tt.t -d testdir                     # test all files in the directory 'testdir'
  tt.r -p testpkg                     # test the (installed) package 'testpkg'
  tt.r -n 1 -p testpkg                # test (installed) package 'testpkg' in serial mode
  tt.r                                # run test_all() iff DESCRIPTION && inst/tinytest/

tt.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

sideeffects <- if (opt$effects) FALSE else TRUE       # by default, use side effects
                                        #ncpu <- if (opt$ncpu) as.integer(opt$ncpu) else getOption("Ncpus", 1)

if (opt$ncpus == "getOption") {
    opt$ncpus <- getOption("Ncpus", 1L)
} else if (opt$ncpus == "-1") {
    ## parallel comes with R 2.14+
    opt$ncpus <- max(1L, parallel::detectCores())
} else {
    opt$ncpus <- as.integer(opt$ncpus)
}


res <- NULL
if (opt$all) {
    res <- test_all(if (length(opt$ARG) == 0) "." else opt$ARG, side_effects=sideeffects)
} else if (opt$build) {
    res <- build_install_test(if (length(opt$ARG) == 0) "." else opt$ARG, side_effects=sideeffects, ncpu=opt$ncpus)
} else if (opt$file) {
    res <- run_test_file(opt$ARG, side_effects=sideeffects)
} else if (opt$directory) {
    res <- run_test_dir(opt$ARG, side_effects=sideeffects)
} else if (opt$package) {
    if (opt$ncpus == 1L) {
        res <- test_package(opt$ARG, side_effects=sideeffects)
    } else {
        res <- test_package(opt$ARG, side_effects=sideeffects, ncpu=opt$ncpus)
    }
} else if (file.exists("DESCRIPTION") && dir.exists("inst/tinytest")) {
    res <- test_all(".", side_effects=sideeffects)
}

if (!opt$silent && !is.null(res)) print(res)

#!/usr/bin/env r

library(docopt)

## configuration for docopt
doc <- "Usage: kitten.r [-p] [-h] [-x] PACKAGE

-p --puppy	      invoke tinytest::puppy to set up testing
-h --help             show this help text
-x --usage            show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  kitten.r

kitten.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

## maybe support path, author, maintainer, email, license, ...
pkgKitten::kitten(opt$PACKAGE)
if (opt$puppy) {
    stopifnot(requireNamespace("tinytest", quietly=TRUE))
    tinytest::puppy(opt$PACKAGE)
}

#!/usr/bin/env r
#
# Convert NEWS.Rd to markdown
#
# Copyright (C) 2016 - 2017  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)
library(tools)

## configuration for docopt
doc <- "Usage: rd2md.r [-h] [-x] [--src REPODIR] [--out OUTDIR] [FILES...]

-s --src REPODIR      source root directory [default: ~/git]
-o --out OUTDIR       output directory [default: /tmp]
-h --help             show this help text
-x --usage            show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  rd2md.r foo                                  # implies conversion of ~/git/foo/inst/NEWS.Rd
  rd2md.r ~/git/foo/inst/NEWS.Rd               # converts given file to markdown

rd2md.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

## helper function
convertArg <- function(p, src, out) {
    filename <- mdfile <- NULL
    if (file.exists(p)) {
        filename <- p
        mdfile <- paste0(filename, ".md")
    } else {
        filename <- file.path(src, p, "inst", "NEWS.Rd")
        if (!file.exists(filename)) {
            stop("No matching file found for ", p, call.=FALSE)
        }
        mdfile <- file.path(out, paste0(p, ".news.md"))
    }
    htmlfile <- paste0(filename, ".html")
    Rd2HTML(filename, htmlfile)
    cmd <- paste("pandoc", htmlfile, "-o", mdfile)
    system(cmd)
    unlink(htmlfile)
    cat("Converted", filename, "into", mdfile, "\n")
}

## insert packages using helper function
sapply(opt$FILES, convertArg, opt$src, opt$out)

#!/usr/bin/env r
#
# Another example to check one or more packages, with option parsing
#
# Copyright (C) 2015 - 2020  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: check.r [-h] [-x] [--as-cran] [--repo REPO] [--no-manvig] [--install-deps] [--install-kitchen] [--deb-pkgs PKGS...] [--use-sudo] [--library LIB] [--setwd DIR] [TARGZ ...]

-a --as-cran          customization similar to CRAN's incoming [default: FALSE]
-r --repo REPO        repository to use, or NULL for file [default: https://cloud.r-project.org]
-n --no-manvig        set the '--no-manual --no-vignettes' options [default: FALSE]
-i --install-deps     also install packages along with their dependencies [default: FALSE]
-k --install-kitchen  even install packages 'kitchen sink'-style up to suggests [default: FALSE]
-l --library LIB      when installing use this library [default: /usr/local/lib/R/site-library]
-s --setwd DIR        change to this directory before undertaking the test [default: ]
-d --deb-pkgs PKGS    also install binary .deb packages with their dependencies [default: FALSE]
-u --use-sudo         use sudo when installing .deb packages [default: TRUE]
-h --help             show this help text
-x --usage            show help and short example usage"

## docopt parsing
opt <- docopt(doc)

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  check.r -a -i -s /tmp myPkg_1.2-3.tar.gz    # run a check --as-cran with depends in /tmp
                                              # for package myPkg_1.2-3.tar.gz

check.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

args <- character()
if (opt$as_cran) args <- c(args, "--as-cran")
if (opt$no_manvig) args <- c(args, "--no-manual", "--no-vignettes")

if (!is.null(opt$libdir)) .libPaths(opt$libdir)

r <- getOption("repos")
r["CRAN"] <- opt$repo
options(repos = r)

hasRcmdcheck <- requireNamespace("rcmdcheck", quietly=TRUE)
if (hasRcmdcheck) suppressMessages(library("rcmdcheck"))

## helper functions
checkArg <- function(p, args) {
    if (hasRcmdcheck) {
        #if (length(args) == 0) args <- ""
        res <- rcmdcheck(p, args=args)
    } else {
        tools:::.check_packages(c(p, args))
        res <- NULL
    }
    res
}

## helper function which switches to local (ie NULL) repo if matching file is presented
installArg <- function(p, lib, rep) {
    p <- gsub("_.*tar\\.gz$", "", p)
    install.packages(pkgs=p,
                     lib=lib,
                     repos=rep,
                     dependencies=if(opt$install_kitchen)
                                      c("Depends", "Imports", "LinkingTo", "Suggests")
                                  else
                                      TRUE
                     )
}

## if binary .deb files are to be installed first:
if (length(opt$deb_pkgs) > 1 || opt$deb_pkgs != FALSE) {
    cmd <- paste0(if (opt$use_sudo) "sudo " else "",
                 "apt-get install -y ", paste(opt$deb_pkgs, collapse=" "))
    system(cmd)
}

## if dependencies (or even suggests) are to be installed first:
if (opt$install_deps || opt$install_kitchen) sapply(opt$TARGZ, installArg, opt$lib, opt$repo)

## change directory if a target directory was given
if (!is.null(opt$setwd)) setwd(opt$setwd)

## installation given selected options and arguments
sapply(opt$TARGZ, checkArg, args)

#!/usr/bin/env r
#
# A second example to install one or more packages, now with option parsing
#
# Copyright (C) 2011 - 2014  Dirk Eddelbuettel
# Copyright (C) 2014 - 2017  Carl Boettiger and Dirk Eddelbuettel
# Copyright (C) 2018         Carl Boettiger, Dirk Eddelbuettel, and Brandon Bertelsen
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: install2.r [-l LIBLOC] [-h] [-x] [-s] [-d DEPS] [-n NCPUS] [-r REPOS...] [--error] [--] [PACKAGES ...]

-l --libloc LIBLOC  location in which to install [default: /usr/local/lib/R/site-library]
-d --deps DEPS      install suggested dependencies as well [default: NA]
-n --ncpus NCPUS    number of processes to use for parallel install [default: getOption]
-r --repos REPOS    repositor(y|ies) to use, or NULL for file [default: getOption]
-e --error          throw error and halt instead of a warning [default: FALSE]
-s --skipinstalled  skip installing already installed packages [default: FALSE]
-h --help           show this help text
-x --usage          show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where PACKAGES... can be one or more CRAN package names, or local (binary or source)
package files (where extensions .tar.gz, .tgz and .zip are recognised). Optional
arguments understood by R CMD INSTALL can be passed interspersed in the PACKAGES, though
this requires use of '--'.

Examples:
  install2.r -l /tmp/lib Rcpp BH                    # install into given library
  install2.r -- --with-keep.source drat             # keep the source
  install2.r -- --data-compress=bzip2 stringdist    # prefer bz2 compression
  install2.r \".\"                                  # install package in current directory
  install2.r -n 6 ggplot2                           # parallel install: (6 processes)

install2.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (opt$deps == "TRUE" || opt$deps == "FALSE") {
    opt$deps <- as.logical(opt$deps)
} else if (opt$deps == "NA") {
    opt$deps <- NA
}

if (length(opt$repos) == 1) {
    ## docopt results are characters, so if we meant NULL we have to set NULL
    if (opt$repos == "NULL")  {
        opt$repos <- NULL
    } else {
        if (opt$repos == "getOption") {
            ## as littler can now read ~/.littler.r and/or /etc/littler.r we can preset elsewhere
            opt$repos <- getOption("repos")
        }
    }
}

if (opt$ncpus == "getOption") {
    opt$ncpus <- getOption("Ncpus", 1L)
} else if (opt$ncpus == "-1") {
    ## parallel comes with R 2.14+
    opt$ncpus <- max(1L, parallel::detectCores())
}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

install_packages2 <- function(pkgs, ..., error = FALSE, skipinstalled = FALSE) {
    e <- NULL
    capture <- function(e) {
        if (error) {
            catch <-
                grepl("download of package .* failed", e$message) ||
                grepl("(dependenc|package).*(is|are) not available", e$message) ||
                grepl("installation of package.*had non-zero exit status", e$message)
            if (catch) {
                e <<- e
            }
        }
    }
    if (skipinstalled) {
        pkgs <- setdiff(pkgs, installed.packages()[,1])
    }
    if (length(pkgs) > 0) {
        withCallingHandlers(install.packages(pkgs, ...), warning = capture)
        if (!is.null(e)) {
            stop(e$message, call. = FALSE)
        }
    }
}

## helper function to for existing files with matching extension
isMatchingFile <- function(f) (file.exists(f) && grepl("(\\.tar\\.gz|\\.tgz|\\.zip)$", f)) || (f == ".")

## helper function which switches to local (ie NULL) repo if matching file is presented
installArg <- function(f, lib, rep, dep, iopts, error, skipinstalled, ncpus) {
    install_packages2(pkgs=f,
                      lib=lib,
                      repos=if (isMatchingFile(f)) NULL else rep,
                      dependencies=dep,
                      INSTALL_opts=iopts,
                      Ncpus = ncpus,
                      error = error,
                      skipinstalled = skipinstalled)
}

## strip out arguments to be passed to R CMD INSTALL
isArg <- grepl('^--',opt$PACKAGES)
installOpts <- opt$PACKAGES[isArg]
opt$PACKAGES <- opt$PACKAGES[!isArg]

if (length(opt$PACKAGES)==0 && file.exists("DESCRIPTION") && file.exists("NAMESPACE")) {
    ## we are in a source directory, so build it
    message("* installing *source* package found in current working directory ...")
    opt$PACKAGES <- "."
}

## helper function to for existing files with matching extension
isMatchingFile <-
    function(f) (file.exists(f) &&
                 grepl("(\\.tar\\.gz|\\.tgz|\\.zip)$", f)) || (f == ".")

## check arguments for local files -- if none, then we can pass vector on
isLocal <- sapply(opt$PACKAGES, isMatchingFile)

## for any local sources loop explicitly as before, otherwise for remote
## packages pass vector to install_packages2 which does the rest (and
## possibly in parallel using up to ncpus)
if (any(isLocal)) {
    sapply(opt$PACKAGES, installArg, opt$libloc, opt$repos, opt$deps,
           installOpts, opt$error, opt$skipinstalled, opt$ncpus)
} else {
    install_packages2(pkgs = opt$PACKAGES,
                      lib = opt$libloc,
                      repos = opt$repos,
                      dependencies = opt$dep,
                      INSTALL_opts = installOpts,
                      Ncpus = opt$ncpus,
                      error = opt$error,
                      skipinstalled = opt$skipinstalled)
}

## clean up any temp file containing CRAN directory information
sapply(list.files(path=tempdir(), pattern="^(repos|libloc).*\\.rds$", full.names=TRUE), unlink)

#!/usr/bin/env r
#
# A simple example to do operations on files
#
# Copyright (C) 2014  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## read files
files <- dir("..", full.names=TRUE)

## creation time as Date
ctimes <- as.Date(file.info(files)$ctime)

## select based on time window -- something arbitrary
now <- Sys.Date()
## these are appromiximative, could be refined using DateTimeClasses
sixmon <- now - 365.25/2
twelvemon <- now - 365.2

ind <- ctimes >= twelvemon & ctimes <= sixmon

if (sum(ind) > 0) {
    cat("The following files are between six and twelve months old\n")
    print(files[ind])
}

## do something
##   print(files[ind])
## or rename / move to subdir
##   mkdir("newDir")
##   file.rename(files[ind], "newDir")
## can also use gsub() etc to rename

#!/usr/bin/env r
#
# Another example to convert markdown
#
# Copyright (C) 2016 - 2019  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: render.r [-c] [-h] [-x] [FILES...]

-c --compact         compact pdf file [default: FALSE]
-h --help            show this help text
-x --usage           show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  render.r foo.Rmd bar.Rmd        # convert two given files

render.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

library(rmarkdown)

## helper function
renderArg <- function(p) {
    if (!file.exists(p)) stop("No file '", p, "' found. Aborting.", call.=FALSE)
    render(p)
    if (opt$compact) {
        s <- gsub(".Rmd$", ".pdf", p)
        if (file.exists(s)) tools::compactPDF(s, gs_quality="ebook")
    }
}

## render files using helper function
sapply(opt$FILES, renderArg)

#!/usr/bin/env r
#
# A simple example to install one or more packages from GitHub
#
# Copyright (C) 2014 - 2017  Carl Boettiger, Dirk Eddelbuettel and Alexios Galanos
#
# Released under GPL (>= 2)

## load docopt and remotes (or devtools) from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
    library(remotes)    	  # can use devtools as a fallback
})

## configuration for docopt
doc <- "Usage: installRepo.r [-l LIBLOC] [-h] [-x] [-d DEPS] [-r REPOS] [-s subdir] [SRC]

-l --libloc LIBLOC  location in which to install [default: /usr/local/lib/R/site-library]
-d --deps DEPS      Install suggested dependencies as well? [default: NA]
-r --repos REPOS    The repository, eg github, bitbucket, svn, or url [default: github]
-s --subdir SUBDIR  For svn or url, an optional sub-directory within the repo
-h --help           show this help text
-x --usage          show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where SRC is either a git-style repo (author/repo) or a URL for svn.

Examples:
  installRepo.r RcppCore/RcppEigen                       # standard GitHub
  installRepo..r -r bitbucket alexiosg/rugarch           # using  BitBucket instead
  installRepo.r -r svn https://github.com/hadley/stringr # from Subversion or a URL
  installRepo.r -r url https://cran.rstudio.com/src/contrib/Archive/digest/digest_0.5.0.tar.gz

installRepo.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (opt$deps == "TRUE" || opt$deps == "FALSE") {
    opt$deps <- as.logical(opt$deps)
} else if (opt$deps == "NA") {
    opt$deps <- NA
}
if (is.null(opt$SRC)) q("no")           # need optional args to support -x

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

## installation given selected options and arguments
switch(tolower(opt$repos),
       github = install_github(opt$SRC, lib=opt$libloc, dependencies=opt$deps),
       bitbucket = install_bitbucket(opt$SRC, lib=opt$libloc, dependencies=opt$deps),
       svn = install_svn(opt$SRC, subdir=opt$subdir, lib=opt$libloc, dependencies=opt$deps),
       url = install_url(opt$SRC, subdir=opt$subdir, lib=opt$libloc, dependencies=opt$deps))

#!/usr/bin/env r
#
# A simple example to install RStudio Desktop
#
# Copyright (C) 2014 - 2020  Carl Boettiger and Dirk Eddelbuettel
#
# Released under GPL (>= 2)
#
# based on earlier https://raw.githubusercontent.com/rocker-org/rstudio-daily/master/latest.R
#
# todo: cmdline options for different download options

suppressMessages(library(rvest))

setwd("/tmp")                           # go to /tmp

#url <- "https://dailies.rstudio.com/rstudio/oss/xenial/amd64/"
#url <- "https://dailies.rstudio.com/rstudio/oss/ubuntu/amd64/"
#url <- "https://dailies.rstudio.com/rstudio/oss/xenial/x86_64"
url <- "https://dailies.rstudio.com/rstudio/oss/bionic/x86_64"
pg <- read_html(url(url))
tb <- html_table(html_nodes(pg, "table"))[[1]]
file <- tb[1,1]
#s3url <- "https://s3.amazonaws.com/rstudio-ide-build/desktop/xenial/amd64/"
#s3url <- "https://s3.amazonaws.com/rstudio-ide-build/desktop/trusty/amd64/"
s3url <- "https://s3.amazonaws.com/rstudio-ide-build/desktop/bionic/amd64/"
fileurl <- paste0(s3url, file)
download.file(fileurl, file, method="wget")

## ## probably simpler
## ## cf https://support.rstudio.com/hc/en-us/articles/203842428-Getting-the-newest-RStudio-builds
## fileurl <- "http://www.rstudio.org/download/latest/daily/desktop/ubuntu64/rstudio-latest-amd64.deb"
## download.file(fileurl, "rstudio-latest-amd64.deb", method="wget")

#!/usr/bin/env r
#
# Simple helper script for simplermarkdown, reusing the older one for knitr
#
# Dirk Eddelbuettel, May 2013, Dec 2021
#
# GPL-2 or later

if (is.null(argv)) {
    cat("Need an argument FILE.md\n")
    q(status=-1)
}


file <- argv[1]
if (!file.exists(file)) {
    cat("File not found: ", file, "\n")
    q(status=-1)
}

simplermarkdown::mdweave_to_html(file)

#!/usr/bin/env -S r -t
#
# upload to cran
#
# Copyright (C) 2025  Dirk Eddelbuettel
#
# Inspired by devtools::upload_cran() from which it takes parts and remixes
# them here.  Released under the same license as that file (ie MIT) or under
# GPL (>= 2) like the rest of this package, at your chooosing.

if (!requireNamespace("httr", quietly=TRUE))
    stop("Please install 'httr' from CRAN.", call. = FALSE)
if (!requireNamespace("whoami", quietly=TRUE))
    stop("Please install 'whoami' from CRAN.", call. = FALSE)

## load docopt from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

## defaults
author <- whoami::fullname()
email <- whoami::email_address()

## configuration for docopt
doc <- paste0("Usage: crup.r [-h] [-x] [-a AU] [-e EM] [ARG]

-a --author AU      author name to use [default: ", author, "]
-e --email EM       email to use [default: ", email, "]
-h --help           show this help text
-x --usage          show help and short example usage")

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where ARG is a (source) package.

Examples:
  crup.r abc_1.2-3.tar.gz             # upload package

crup.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (is.null(opt$ARG)) {
    q("no")
}

if (!file.exists(opt$ARG)) {
    stop("No file '", opt$ARG, "' found. Existing.", call. = FALSE)
}


msg <- list(pkg_id = "",
            name = author,
            email = email,
            uploaded_file = httr::upload_file(argv[1], "application/x-gzip"),
            upload = "Upload package")

res <- httr::POST("https://xmpalantir.wu.ac.at/cransubmit/index2.php", body = msg)

httr::stop_for_status(res)
url <- httr::parse_url(res$url)

msg2 <- list(pkg_id = url$query$pkg_id,
             name = author,
             email = email,
             policy_check = "1/",
             submit = "Submit package")
res2 <- httr::POST("https://xmpalantir.wu.ac.at/cransubmit/index2.php", body = msg2)

httr::stop_for_status(res2)
url2 <- httr::parse_url(res2$url)

if (url2$query$submit == "1") {
    cat("Package submission complete. See incoming email for confirmation link.\n")
} else {
    stop("Upload failed.", call. = FALSE)
}

#!/usr/bin/env r
#
# A simple example to check the incoming queue at CRAN
#
# Copyright (C) 2020 - present  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

if (!requireNamespace("foghorn", quietly=TRUE))
    stop("The 'bspm' is required. Please install it.", call.=FALSE)

## configuration for docopt
doc <- paste0("Usage: cranIncoming.r [-a] [-h] [-x] [ARGS...]
-a --all         show everything in incoming
-h --help        show this help text
-x --usage       show help and short example usage
")

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("

Basic usage:

  cranIncoming.r digest binb

cranIncoming.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (length(opt$ARGS) == 0) opt$ARGS <- if (opt$all) NULL else character()
print(data.frame(foghorn::cran_incoming(opt$ARGS)), row.names=FALSE)

#!/usr/bin/env r
longline <- function(len){
	n <- floor(len/10)
	m = len %% 10
	if (m>0){
		x <- paste(rep(seq(0,9),n),collapse='')
		y <- paste(seq(0,m-1),collapse='')
		z <- paste(x,y,sep='')
	} else {
		z <- paste(rep(seq(0,9),n),collapse='')
	}
	z
}
cat("x<-\"", longline(1020), "\";",sep="");
cat("cat(x,\"\\n\"",")\n",sep="");
cat("cat(nchar(x),\"\\n\"",")\n",sep="");

#!/usr/bin/env r

# function to be called at exit
.Last <- function() { cat("Really done, so bye-bye from .Last\n") }

# imagine we're doing something now...

# end, and .Last is now called
q(status=42)

##
##  littler - Provides hash-bang (#!) capability for R (www.r-project.org)
##
##  Copyright (C) 2006 - 2017  Jeffrey Horner and Dirk Eddelbuettel
##
##  littler is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##

ExcludeVars <- c("R_SESSION_TMPDIR", "R_HISTFILE", "R_LIBS_USER",
                 "R_LIBRARY_DIR", "R_LIBS", "R_PACKAGE_DIR", "R_USER")
IncludeVars <- Sys.getenv()
IncludeVars <- IncludeVars[grep("^R_", names(IncludeVars), perl=TRUE)]
cat("const char *R_VARS[] = {\n")
for (i in 1:length(IncludeVars)){
    if (names(IncludeVars)[i] %in% ExcludeVars) next
    cat('"',names(IncludeVars)[i], '","', IncludeVars[i], '",\n', sep='')
}
cat("NULL };\n")

#!/usr/bin/env r
#
# A simple example to install one or more packages
#
# Note that a more featureful version exists in install2.r
# with an added dependency on the 'docopt' argument parser
#
# Copyright (C) 2006 - 2019  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

if (is.null(argv) | length(argv) < 1) {
    if (file.exists("DESCRIPTION") && file.exists("NAMESPACE")) {
        ## we are in a source directory, so build it
        message("* installing *source* package found in current working directory ...")
        argv <- "."
    } else {
        cat("Usage: installr.r pkg1 [pkg2 pkg3 ...]\n\n")
        cat("Installs pkg1, ... from existing files with matching extension.\n")
        cat("Use \".\" to install the package in current working directory.\n\n")
        cat("Use (remote) packages pkgname1 pkgname2 pkgname3 ... for parallel\n")
        cat("installation if 'Ncpus' option is set (or multiple cores present).\n\n")
        cat("Set environment variables REPOS and LIBLOC to overrride defaults.\n\n")
        q()
    }
}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

## adjust as necessary, see help('download.packages')
## littler can now read ~/.littler.r and /etc/littler.r to set this
repos <- getOption("repos")
## NULL means install file, and we supported env var previously
if (Sys.getenv("REPOS") == "NULL") repos = NULL

## this makes sense on Debian where no packages touch /usr/local
lib.loc <- Sys.getenv("LIBLOC", unset="/usr/local/lib/R/site-library")

## helper function to for existing files with matching extension
isMatchingFile <-
    function(f) (file.exists(f) &&
                 grepl("(\\.tar\\.gz|\\.tgz|\\.zip)$", f)) || (f == ".")

## helper function which switches to local (ie NULL) repo if matching file is presented
installArg <-
    function(f, lib, rep) install.packages(pkgs=f,
                                           lib=lib,
                                           repos=if (isMatchingFile(f)) NULL else repos)


## check arguments for local files -- if none, then we can pass vector on
isLocal <- sapply(argv, isMatchingFile)

if (any(isLocal)) {
    ## use argv [filtered by installArg()], lib.loc and repos to install the packages
    sapply(argv, installArg, lib.loc, repos)
} else {
    ## all remote, so pass argv so Ncpus can enter
    install.packages(pkgs=argv,
                     lib=lib.loc,
                     repos=repos,
                     Ncpus=getOption("Ncpus", max(1L, parallel::detectCores())))
}

## clean up any temp file containing CRAN directory information
sapply(list.files(path=tempdir(), pattern="^(repos|libloc).*\\.rds$", full.names=TRUE), unlink)

#!/usr/bin/env r
##
##  Call 'rcmdcheck' on a package
##
##  Copyright (C) 2016 - 2020  Dirk Eddelbuettel
##
##  Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: rcc.r [-h] [-x] [-c] [-f] [-q] [--args ARGS] [--libpath LIBP] [--repos REPO] [--erroron ERRON] [PATH...]

-c --as-cran          should '--as-cran' be added to ARGS [default: FALSE]
-a --args ARGS        additional arguments to be passed to 'R CMD CHECK' [default: ]
-l --libpath LIBP     additional library path to be used by 'R CMD CHECK' [default: ]
-r --repos REPO       additional repositories to be used by 'R CMD CHECK' [default: ]
-f --fast             should vignettes and manuals be skipped [default: FALSE]
-e --erroron ERRON    whether to throw an error on failure [default: never]
-q --quiet            should 'rcmdcheck' be called qietly [default: FALSE]
-h --help             show this help text
-x --usage            show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  rcc.r                        # check repo in current (working) director
  rcc.r -c                     # run as R CMD check --as-crn

rcc.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

erroron <- switch(opt$erroron,
                  never   = "never",
                  error   = "error",
                  warning = "warning",
                  note    = "note",
                  "badarg")
if (erroron=="badarg")
    stop("Inadmissable argument for '--erroron' option.", call.=FALSE)

if (is.null(opt$args)) {         # special treatment for --args and -c
    if (opt$as_cran) {
        opt$args <- "--as-cran"
    } else {
        opt$args <- character()
    }
} else {
    if (opt$as_cran) {
        opt$args <- c(opt$args, "--as-cran")
    }
}
if (opt$fast) {
    opt$args <- c(opt$args, "--ignore-vignettes", "--no-manual")
}

if (length(opt$PATH) == 0) opt$PATH <- "." 		# default argument current directory
if (is.null(opt$libpath)) opt$libpath <- .libPaths()	# default library pathr
if (is.null(opt$repos)) opt$repos <- getOption("repos")	# default repos

if (requireNamespace("rcmdcheck", quietly=TRUE) == FALSE)
    stop("This command requires the 'rcmdcheck' package.", call.=FALSE)

suppressMessages(library(rcmdcheck))

Sys.setenv("_R_CHECK_TESTS_NLINES_"="0")		# ensure all errors shown

rccwrapper <- function(pa, qu, ar, li, re, eo) {
    rcmdcheck(path=pa, quiet=qu, args=ar, libpath=li, repos=re, error_on=eo)
}

rc <- sapply(opt$PATH,                  # iterate over arguments
             rccwrapper,                # calling 'rcmdcheck()' with arguments
             opt$quiet,                 # quiet argument, default false
             opt$args,			# args arguments, possibly with --as-cran
             opt$libpath,		# libpath argument
             opt$repos,			# repos argument
             erroron,                   # error_on argument
             simplify=FALSE)
status <- max(sapply(rc, "[[", "status"))
q(status=status)

#!/usr/bin/env r 
#
# Convert miles-per-hour, time-distance measure settable
# on treadmiles, to different race times.
#
# Copyright (C) 2006 - 2014  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

if (is.null(argv) | length(argv)<1) {

  cat("Usage: mph.r mph\n")
  q()

}
dig <- 5
mph <- as.numeric(argv[1])

cat("Mph     : ",format(mph,digits=dig),"\n");

hourminsec <- function(totalsecs){
	ret <- list(hour=0,min=0,sec=0)

	ret$hour <- floor(totalsecs / 3600)

	totalsecs <- totalsecs - (ret$hour * 3600)

	ret$min <- floor(totalsecs / 60)

	ret$sec <- totalsecs - (ret$min * 60)

	ret
}

minutes <- floor(60/mph)
pminute <- 60/mph - minutes
secs <- floor(60 * (pminute))
secspermile <-  60*minutes + secs

outrace <- function(title,miles){
	race <- hourminsec(miles*secspermile)
	cat(sprintf("%-8s: %2.f hours %2.f min %2.f sec\n",title, race$hour,race$min, race$sec))
}

kilodiv <- 1.609344 # kilometer divisor
outrace('1 mile',1)
outrace('3 miles',3)
outrace('5k',5/kilodiv)
outrace('10k',10/kilodiv)
outrace('Marathon',42.195/kilodiv)
outrace('Ultra',100)

#!/usr/bin/env r
#
# A simple example to do statistics on files
#
# Copyright (C) 2006 - 2014  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

fsizes <- as.integer(readLines(file("stdin")))
print(summary(fsizes))
stem(fsizes)

#!/usr/bin/env -S r -t
#
# testthat::test_local wrapper
#
# Copyright (C) 2019 - 2024  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

if (!requireNamespace("testthat", quietly=TRUE))
    stop("Please install 'testthat' from CRAN.", call. = FALSE)

## load docopt from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

## configuration for docopt
doc <- "Usage: tttl.r [-h] [-x] [-c] [-s] [ARG]

-c --ci             set environment variable CI to TRUE [default: FALSE]
-s --source         set load package to 'source' not 'installed' [default: FALSE]
-h --help           show this help text
-x --usage          show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where ARG can be a package directory.

Examples:
  tttl.r                              # run test_local() if DESCRIPTION && tests/testthat/
  tttl.r                              # run test_local() if in tests/testthat directory

tttl.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (!is.null(opt$ARG) && dir.exists(opt$arg)) {
    setwd(opt$ARG)
}

if (opt$ci) {
    Sys.setenv(CI="TRUE")
}

if (file.exists(file.path(getwd(), "..", "..", "DESCRIPTION"))) {
    setwd(file.path(getwd(), "..", ".."))
}

if (file.exists(file.path(getwd(), "..", "DESCRIPTION"))) {
    setwd("..")
}

if (file.exists("DESCRIPTION") && dir.exists("tests/testthat")) {
    testthat::test_local("tests/testthat",
                         load_package = if (opt$source) "source" else "installed")
}

#!/usr/bin/env r
#
# A simple example to install dependencies
#
# Copyright (C) 2020 - present  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt and remotes (or devtools) from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
    library(remotes)              # or can use devtools as a fallback
})

## configuration for docopt
doc <- "Usage: installDeps.r [-h] [-x] [ARGS]

-h --help            show this help text
-x --usage           show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("

Basic usage:

  installDeps.r .
  installDeps.r somePackage_1.2.3.tar.gz

installDeps.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (length(opt$ARGS)==0 && file.exists("DESCRIPTION") && file.exists("NAMESPACE")) {
    ## we are in a source directory, so build it
    message("* installing deps for *source* package found in current working directory ...")
    opt$ARGS <- "."
}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

invisible(sapply(opt$ARGS, function(r) install_deps(r)))

#!/usr/bin/env r
#
# A second example to install one or more packages, now with option parsing
#
# Copyright (C) 2011 - 2014  Dirk Eddelbuettel
# Copyright (C) 2014 - 2017  Carl Boettiger and Dirk Eddelbuettel
# Copyright (C) 2018 - 2025  Carl Boettiger, Dirk Eddelbuettel, Brandon Bertelsen, and SHIMA Tatsuya
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## default to first library location in .libPaths()
libloc <- .libPaths()[1]

## configuration for docopt
doc <- paste0("Usage: install2.r [-l LIBLOC] [-h] [-x] [-s] [-d DEPS] [-n NCPUS] [-r REPOS...] [-m METHOD] [-t TYPE] [--error] [--quiet] [--verbose] [--] [PACKAGES ...]

-l --libloc LIBLOC  location in which to install [default: ", libloc, "]
-d --deps DEPS      install suggested dependencies as well [default: NA]
-n --ncpus NCPUS    number of processes to use for parallel install, -1 selects all cores [default: getOption]
-r --repos REPOS    repositor(y|ies) to use, or NULL for file [default: getOption]
-e --error          throw error and halt instead of a warning [default: FALSE]
-s --skipinstalled  skip installing already installed packages [default: FALSE]
-m --method METHOD  method to be used for downloading files [default: auto]
-t --type TYPE      installation type as used by `install.packages` [default: getOption]
-q --quiet          run installation with `quiet` option set [default: FALSE]
-v --verbose        run installation with `verbose` option set [default: FALSE]
-h --help           show this help text
-x --usage          show help and short example usage")
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where PACKAGES... can be one or more CRAN package names, or local (binary or source)
package files (where extensions .tar.gz, .tgz and .zip are recognised). Optional
arguments understood by R CMD INSTALL can be passed interspersed in the PACKAGES, though
this requires use of '--'.

Examples:
  install2.r -l /tmp/lib Rcpp BH                    # install into given library
  install2.r -- --with-keep.source drat             # keep the source
  install2.r -- --data-compress=bzip2 stringdist    # prefer bz2 compression
  install2.r \".\"                                  # install package in current directory
  install2.r -n 6 ggplot2                           # parallel install: (6 processes)

install2.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (opt$deps == "TRUE" || opt$deps == "FALSE") {
    opt$deps <- as.logical(opt$deps)
} else if (opt$deps == "NA") {
    opt$deps <- NA
}

## docopt results are characters, so if we meant NULL we have to set NULL
if (length(opt$repos) == 1 && "NULL" %in% opt$repos) {
    opt$repos <- NULL
}

if ("getOption" %in% opt$repos) {
    ## as littler can now read ~/.littler.r and/or /etc/littler.r we can preset elsewhere
    opt$repos <- c(opt$repos[which(opt$repos != "getOption")], getOption("repos"))
}

if (opt$ncpus == "getOption") {
    opt$ncpus <- getOption("Ncpus", 1L)
} else if (opt$ncpus == "-1") {
    ## parallel comes with R 2.14+
    opt$ncpus <- max(1L, parallel::detectCores())
}

## type should reflects bspm where available
if (opt$type == "getOption") {
    opt$type <- getOption("pkgType")
    #if (requireNamespace("bspm", quietly=TRUE) && Sys.info()[["sysname"]] == "Linux") opt$type <- "binary-source"

}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

install_packages2 <- function(pkgs, ..., error = FALSE, skipinstalled = FALSE) {
    e <- NULL
    capture <- function(e) {
        if (error) {
            catch <-
                grepl("(download|installation) of package .* failed", e$message) ||
                grepl("(dependenc|package).*(is|are) not available", e$message) ||
                grepl("installation of package.*had non-zero exit status", e$message) ||
                grepl("installation of .+ package(|s) failed", e$message)
            if (catch) {
                e <<- e
            }
        }
    }
    if (skipinstalled) {
        pkgs <- setdiff(pkgs, installed.packages()[,1])
    }
    if (length(pkgs) > 0) {
        withCallingHandlers(install.packages(pkgs, ...), warning = capture)
        if (!is.null(e)) {
            stop(e$message, call. = FALSE)
        }
    }
}

## helper function to for existing files with matching extension
isMatchingFile <- function(f) (file.exists(f) && grepl("(\\.tar\\.gz|\\.tgz|\\.zip)$", f)) || (f == ".")

## helper function which switches to local (ie NULL) repo if matching file is presented
installArg <- function(f, lib, rep, dep, iopts, error, skipinstalled, ncpus, method, type, quiet, verbose) {
    install_packages2(pkgs=f,
                      lib=lib,
                      repos=if (isMatchingFile(f)) NULL else rep,
                      dependencies=dep,
                      INSTALL_opts=iopts,
                      Ncpus = ncpus,
                      method = method,
                      type = type,
                      error = error,
                      skipinstalled = skipinstalled,
                      quiet = quiet,
                      verbose = verbose)
}

## strip out arguments to be passed to R CMD INSTALL
isArg <- grepl('^--',opt$PACKAGES)
installOpts <- opt$PACKAGES[isArg]
opt$PACKAGES <- opt$PACKAGES[!isArg]

if (length(opt$PACKAGES)==0 && file.exists("DESCRIPTION") && file.exists("NAMESPACE")) {
    ## we are in a source directory, so build it
    message("* installing *source* package found in current working directory ...")
    opt$PACKAGES <- "."
}

## helper function to for existing files with matching extension
isMatchingFile <-
    function(f) (file.exists(f) &&
                 grepl("(\\.tar\\.gz|\\.tgz|\\.zip)$", f)) || (f == ".")

## check arguments for local files -- if none, then we can pass vector on
isLocal <- sapply(opt$PACKAGES, isMatchingFile)

## for any local sources loop explicitly as before, otherwise for remote
## packages pass vector to install_packages2 which does the rest (and
## possibly in parallel using up to ncpus)
if (any(isLocal)) {
    sapply(opt$PACKAGES, installArg, opt$libloc, opt$repos, opt$deps,
           installOpts, opt$error, opt$skipinstalled, opt$ncpus, opt$method, opt$type,
           opt$quiet, opt$verbose)
} else {
    install_packages2(pkgs = opt$PACKAGES,
                      lib = opt$libloc,
                      repos = opt$repos,
                      dependencies = opt$deps,
                      INSTALL_opts = installOpts,
                      Ncpus = opt$ncpus,
                      method = opt$method,
                      type = opt$type,
                      error = opt$error,
                      skipinstalled = opt$skipinstalled,
                      quiet = opt$quiet,
                      verbose = opt$verbose)
}

## clean up any temp file containing CRAN directory information
sapply(list.files(path=tempdir(), pattern="^(repos|libloc).*\\.rds$", full.names=TRUE), unlink)

##
##  littler - Provides hash-bang (#!) capability for R (www.r-project.org)
##
##  Copyright (C) 2006 - 2016  Jeffrey Horner and Dirk Eddelbuettel
##
##  littler is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##

dp <- getOption("defaultPackages")
#dp <- dp[dp != 'datasets'] ## Rscript loads it too
#dp <- dp[dp != 'methods']  ## Rscript (in R 2.6.1) doesn't load methods either

# Count of default packages
cat("int packc = ",length(dp),";\n",sep='')

# List of packages
cat("const char *pack[] = {\n",paste('"',dp,'"',sep='',collapse=",\n"),"\n};\n")

packobjc <- array(0,dim=length(dp))
packobj <- NULL
for (i in 1:length(dp)){
    obj = ls(paste("package:",dp[i],sep=''))
    packobjc[i] = length(obj)
    packobj = c(packobj,obj)
}

# List of counts of objects per package
cat("int packobjc[] = {\n",paste(packobjc,sep='',collapse=",\n"),"\n};\n")

# List of object names
cat("const char *packobj[] = {\n",paste('"',packobj,'"',sep='',collapse=",\n"),"\n};\n")

#!/usr/bin/env r
##
##  A simple tool to update URLs using R's checker
##
##  Copyright (C) 2020 - present  Dirk Eddelbuettel
##
##  Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

if (!requireNamespace("urlchecker", quietly=TRUE))
    stop("The 'urlchecker' package is required. Please install it from GitHub.", call.=FALSE)

doc <- "Usage: urlUpdate.r [-c] [-h] [PACKAGES ...]

-c --check-only   check-only, i.e. do not auto-update URLs
-h --help         show this help text

Simple wrapper to 'urlchecker::update_url(...)'.
"

opt <- docopt(doc)

if (length(opt$PACKAGES) == 0) opt$PACKAGES <- "." 	# default argument current directory

for (p in opt$PACKAGES)
    if (opt$check_only) print(urlchecker::url_check(p)) else urlchecker::url_update(p)

#!/usr/bin/env r
#
# Minimal rhub::check_on_windows() wrapper
#
# Copyright (C) 2016 - 2020  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

checkargs <- "--no-manual --no-vignettes"
checkfile <- function(f) if (file.exists(f)) rhub::check_on_windows(f, check_args=checkargs)
if (length(argv) == 0) argv <- "."
sapply(argv, checkfile)

#!/usr/bin/env r
#
# A simple example to update packages in /usr/local/lib/R/site-library
# Parameters are easily adjustable
#
# Copyright (C) 2006 - 2019  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: update.r [-r REPO...] [-l LIBLOC] [-n NCPUS] [-h] [-x]

-r --repos REPO     repository to use, or NULL for file [default: getOption]
-l --libloc LIBLOC  path to examine for packages to update [default: NULL]
-n --ncpus NCPUS    number of processes to use for parallel install [default: getOption]
-h --help           show this help text
-x --usage          show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("updates packages, optionally from a given repository, fo a library location.

Examples:
  update.r                                     # update installed packages
  update.r -l /srv/R-lib                       # update for this location

update,r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

## docopt results are characters, so if we meant NULL we have to set NULL
if (opt$repos == "NULL")  {
    opt$repos <- NULL
} else if (opt$repos == "getOption") {
    ## adjust as necessary, see help('download.packages')
    opt$repos <- getOption("repos")
}

if (opt$ncpus == "getOption") {
    opt$ncpus <- getOption("Ncpus", 1L)
} else if (opt$ncpus == "-1") {
    ## parallel comes with R 2.14+
    opt$ncpus <- max(1L, parallel::detectCores())
}

if (opt$libloc == "NULL") {
    ## NULL corresponds to .libPaths() but some directories may be non-writeable
    ## so we filter out the ones where we can write and use only those
    canWrite <- function(d) file.access(d, mode=2) == 0
    opt$libloc <- Filter(canWrite, .libPaths())
}

## ensure installation is stripped
Sys.setenv("_R_SHLIB_STRIP_"="true")

## simply unrolling of all unlink over all files 'repos*' in $TMP
clearCache <- function() {
    sapply(list.files(path=tempdir(), pattern="*rds$", full.names=TRUE), unlink)
}

## Always clear caches of remote and local packages
clearCache()

update.packages(lib.loc=opt$libloc, repos=opt$repos, Ncpus=opt$ncpus, ask=FALSE)

## Always clear caches of remote and local packages
clearCache()

#!/usr/bin/env -S r -t
#
# upload to winbuilder
#
#
# Copyright (C) 2025  Dirk Eddelbuettel

if (!requireNamespace("curl", quietly=TRUE))
    stop("Please install 'curl' from CRAN.", call. = FALSE)

## load docopt from CRAN
suppressMessages({
    library(docopt)               # we need docopt (>= 0.3) as on CRAN
})

## configuration for docopt
doc <- "Usage: wb.r [-h] [-x] [-d] [-v] [ARG]

-v --verbose        use the 'verbose' flag in curl upload [default: FALSE]
-d --devel          upload to 'devel' instead of 'release' [default: FALSE]
-h --help           show this help text
-x --usage          show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where ARG is a (source) package.

Examples:
  wb.r abc_1.2-3.tar.gz               # upload package to win-builder for (default) release build
  wb.r -d abc_1.2-3.tar.gz            # upload package to win-builder for devel build

wb.r is part of littler which brings 'r' to the command-line.
See https://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

if (is.null(opt$ARG)) {
    q("no")
}

if (!file.exists(opt$ARG)) {
    stop("No file '", opt$ARG, "' found. Existing.", call. = FALSE)
}

url <- file.path("ftp://win-builder.r-project.org", if (opt$devel) "R-devel/" else "R-release/")

curl::curl_upload(opt$ARG, url, verbose = opt$verbose)

#!/usr/bin/env r
#
# Another example to run a shiny app
#
# Copyright (C) 2015  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt package from CRAN
library(docopt)

## same as runApp()
host <- getOption("shiny.host", "127.0.0.1")

## configuration for docopt
doc <- paste0("Usage: shiny.r [-h] [--port PORT] [--host HOST] [--dir DIR]

-p --port PORT      port to use [default: NULL]
-o --host HOST      host string to use [default: ", host, "]
-d --dir DIR        directoru run application from [default: .]
-h --help           show this help text")

## docopt parsing
opt <- docopt(doc)

suppressMessages(library(shiny))
runApp(opt$dir, port=as.integer(opt$port), host=opt$host)

#!/usr/bin/env r
#
# Minimal rhub::check_on_macos() wrapper
#
# Copyright (C) 2016 - 2020  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

##rhub::check_on_macos(check_args="--no-manual --no-vignettes")
## cf https://github.com/r-hub/rhub/issues/368
macos <- "macos-highsierra-release-cran"
checkfile <- function(f) if (file.exists(f)) rhub::check(f, platform=macos)
if (length(argv) == 0) argv <- "."
sapply(argv, checkfile)

.onAttach <- function(libname, pkgname) {
    packageStartupMessage("The littler package provides 'r' as a binary.")
    packageStartupMessage("See 'vignette(\"littler-examples\") for several usage illustrations,")
    packageStartupMessage("and see 'vignette(\"littler-faq\") for some basic questions.")
    if (Sys.info()[["sysname"]] %in% c("Linux", "Darwin")) { # nocov start
        if (unname(Sys.which("r")) == "") {
            loc <- normalizePath(system.file("bin", .Platform$r_arch, "r", package="littler"))
            packageStartupMessage("You could link to the 'r' binary installed in\n'", loc, "'\n",
                                  "from '/usr/local/bin' in order to use 'r' for scripting.",
                                  "See the 'vignette(\"littler-faq\")' for more details.")
        if (Sys.info()[["sysname"]] == "Darwin")
            packageStartupMessage("On maxOS, 'r' and 'R' are the same so 'lr' is a possible alternate name for littler.")
        } # nocov end
    }
}

#!/usr/bin/env r
#
# Simple helper script for tinyrox::document()
#
# Dirk Eddelbuettel, 2026 - current
#
# GPL-2 or later

## load docopt package from CRAN
library(docopt)

## configuration for docopt
doc <- "Usage: trox.r [-h] [-x] [PACKAGES ...]

-h --help             show this help text
-x --usage            show help and short example usage"
opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("where PACKAGES... can be one or more packages.

Examples:
  trox.r                   # update help pages for package

trox.r is part of littler which brings 'r' to the command-line. See the help for
tinyrox for detials. See https://dirk.eddelbuettel.com/code/littler.html for more
information.\n")
    q("no")
}

## load tinyrox
library(tinyrox)

## check all command-line arguments (if any are given) for directory status
argv <- Filter(function(x) file.info(x)$is.dir, argv)

## loop over all argument, with fallback of the current directory, and
## call document() on the given directory
sapply(ifelse(length(argv) > 0, argv, "."), FUN = document)

#!/bin/bash

## run this test from the build directory, ie above tests/
littler=./r

echo "Shebang 1"
$littler tests/shebang foo
echo "Shebang 2"
$littler tests/shebang foo bar
echo "Shebang 2, verbose"
$littler  --verbose tests/shebang foo bar

echo "Piping a file to r"
cat tests/test1.R | $littler
echo "Piping a file to r -"
cat tests/test1.R | $littler -

echo "Looking at what argv contains"
$littler -e 'print(argv)' -- -a -b
echo "Looking at what argv contains, piped"
echo 'print(argv)' | $littler - -- -a -b

echo ""
echo "Eval expr: cat('Hello, world\n')"
$littler -e "cat('Hello, world\n')"
echo "Eval expr: a=2;print(\"a^2\")"
$littler --verbose -e 'a<-2; cat(a^2,"\n")'

echo ""
echo "Jeffrey's Grand Test of Tukey summary() of /bin/ls output"
ls -l | awk '!/^total/ {print $5}' | $littler -e 'print(summary(as.integer(readLines())))'

#!/bin/bash

N=20

function loopLittleR {
    echo
    echo -n " --- our r calling summary() $N times"
    i=0
    while [ $i -lt $N ]
    do
	./summary2.R >/dev/null
	i=$((i + 1))
    done
}

function loopRscript {
    echo
    echo -n " --- GNU R's Rscript calling summary() $N times"
    i=0
    while [ $i -lt $N ]
    do
	Rscript ./summary2.R >/dev/null
	i=$((i + 1))
    done
}

function loopR {
    echo
    echo -n " --- GNU R calling summary() $N times"
    i=0
    while [ $i -lt $N ]
    do
	R --silent --vanilla < ./summary2.R >/dev/null
	i=$((i + 1))
    done
}

time loopLittleR
time loopRscript
time loopR

#!/bin/bash

N=10
function loopBC {
    echo 
    echo -n " --- GNU bc doing the addition $N times"
    i=0
    while [ $i -lt $N ]
    do
	echo "1+2" | bc -l > /dev/null
	i=$((i + 1))
    done
}

function loopLittleR {
    echo
    echo -n " --- our r doing the addition $N times"
    i=0
    while [ $i -lt $N ]
    do
	echo "cat(1+2,'\n')" | ../r --vanilla > /dev/null
	i=$((i + 1))
    done
}

function loopRscript {
    echo
    echo -n " --- GNU R's Rscript doing the addition $N times"
    i=0
    while [ $i -lt $N ]
    do
	echo "cat(1+2,'\n')" | Rscript - > /dev/null
	i=$((i + 1))
    done
}

function loopR {
    echo
    echo -n " --- GNU R doing the addition $N times"
    i=0
    while [ $i -lt $N ]
    do
	echo "cat(1+2,'\n')" | R --slave --vanilla > /dev/null
	i=$((i + 1))
    done
}

time loopBC
time loopLittleR
time loopRscript
time loopR

#!/bin/bash

echo "Testing value of 'q(status=...)' exits for r:"
echo "q(status=123)" | ../r  
echo "  Got: $? via stdin"

echo "q(status=124)" | ../r -
echo "  Got: $? via file '-'"

../r -e "q(status=125)" 
echo "  Got: $? from 'r -e'"

tempfile=`tempfile`
echo "q(status=126)" > $tempfile
../r $tempfile
echo -n "  Got: $? from temp. file and "
rm -v $tempfile


echo "Testing value of 'q(status=...)' exits for Rscript:"
echo "q(status=123)" | Rscript -
echo "  Got: $? via stdin"

Rscript -e "q(status=124)" 
echo "  Got: $? from 'r -e'"

tempfile=`tempfile`
echo "q(status=125)" > $tempfile
Rscript $tempfile
echo -n "  Got: $? from temp. file and "
rm -v $tempfile

<!--
%\VignetteEngine{simplermarkdown::mdweave_to_html}
%\VignetteIndexEntry{Littler FAQ}
%\VignetteEncoding{UTF-8}
-->
---
title: "Littler FAQ"
author: "Dirk Eddelbuettel"
date: "2019-03-23, updated 2020-06-16"
css: "water.css"
---

### Well, why?

Glad you asked. When the initial work started, `Rscript` did not exist so
there was no scripting tool. We take a small amount of pride into beating
`Rscript` narrowly to a first release.  Of course, by now, `Rscript` is more
widely used as it ships with every R installation but we still have some
aspects we like about `r`: it is simpler and shorter, deals (in our biased)
view more sanely with command-line arguments via the `argv` vector, always
loaded package `methods` (which `Rscript` finally came around to a good
decade later) and [still starts
faster](http://dirk.eddelbuettel.com/blog/2014/09/02/#littler-faster-at-doing-nothing).
And `r` is just to cool a command (in relation to the trusted `R`) so someone
had to!

### No Printing

In the very beginning of `littler`, we made an executive decision to _not_
echo each command output when we evaluate commands in the read-evaluate-print
loop.  So `2+2` will be evaluated silently: four will be computed, but not shown.

That made sense for scripts we wanted to be silent. The idea is that user
will add a `print()` or `cat()` as needed.  If you desire each step to
printed, add a `-p` or `--verbose` argument.


### No `.Renviron`

Another early decision was to make `r` start _faster_ than the alternatives.
Our `r` is "just" a small little binary.  Whereas `R` and `Rscript` are
front-end shell scripts sourcing a number of things and setting them
dynamically, we determine values _at compilation time_ and freeze them into
the binary.  That may seem _risqué_ but worked out just fine.  However, while
we later added the ability to source `Rprofile` files (which contain R code
we can evaluate) there is no way for us to source the `Renviron` files _and
to modify the already running process_.  So if you want to source `Renviron`
you could add an explicit `readEnviron()` to `~/.littler.r` or
`/etc/littler/r`. 

### Lower-case / upper-case

This is mostly an issue on macOS where the brain surgeons behind the OS
decided that `r` is the same as `R`. What can we say?  On that OS you may
need to rename the build to `lr` instead.  Please send your complaints to
Cupertino, California. 

### Adding the binary to your path

When the package is installed from source, it displays 

```
*
* new binary $(TGT) installed in bin/ subdirectory"
* consider adding a symbolic link from, e.g., /usr/local/bin"
* on OS X, you may have to name this 'lr' instead"
* see the littler-faq vignette for more details"
*
```

where the variable `$(TGT)` normally expands to `r`. As the text suggests you may 
want to create a [symbolic link](https://en.wikipedia.org/wiki/Symbolic_link) from a
directory in the to make the newly built binary available to users.  On Linux you 
may do

```
cd /usr/local/bin 
sudo ln -s /usr/local/lib/R/site-library/littler/bin/r .
```

to create a link for `r` in `/usr/local/bin`.  On macOS, as suggested, you may want

```
cd /usr/local/bin 
sudo ln -s /usr/local/lib/R/site-library/littler/bin/r lr
```

to create a command `lr` instead; see the previous question as to why.  In either case
adjust the source part of the `ln` command to where your binary is -- which R can tell 
you via `system.file("bin", "r", package="littler")`.

Also note that _e.g._ the [zsh](https://zsh.sourceforge.io/) has a builtin
command `r` which may conflict, so using the explicit path of, say,
`/usr/bin/r` or `/usr/local/bin/r` or ... may provide an alternative.

<!--
%\VignetteEngine{simplermarkdown::mdweave_to_html}
%\VignetteIndexEntry{Littler Examples}
%\VignetteEncoding{UTF-8}
-->
---
title: "Littler Examples"
author: "Dirk Eddelbuettel"
date: "Originally written 2015-10-28; Updated 2017-12-10, 2018-05-24, 2019-01-06, 2019-06-09 and 2020-06-16"
css: "water.css"
---

## Overview

We show and discuss a few of the files included in the `inst/examples/` source directory of
[littler](http://dirk.eddelbuettel.com/code/littler.html) (which becomes the `examples/` directory 
once installed). In a few cases we remove comment lines to keep things more concise on this page.
We use `$` to denote a shell (_i.e._ terminal) prompt.

Note that some systems (such as macOS) cannot install littler as `r` (as lower-case and upper-case
are by default the same; not a great idea).  And for example the `zsh` has `r` as a builtin so you
would have to use `/usr/bin/r`.  See the [littler FAQ](littler-faq.html) for more.

## Simple Direct Command-line Use

[littler](http://dirk.eddelbuettel.com/code/littler.html) can be used
directly on the command-line just like, say, `bc`, easily consuming standard
input from a pipe: 

```bash
$ echo 'cat(pi^2,"\n")' | r
9.869604
```

Equivalently, commands that are to be evaluated can be given on
the command-line

```bash
$ r -e 'cat(pi^2, "\n")'
9.869604
```

But unlike bc(1), GNU R has a vast number of statistical
functions. For example, we can quickly compute a `summary()` and show
a stem-and-leaf plot for file sizes in a given directory via

```bash
$ ls -l /boot | awk 'BEGIN {print "size"} !/^total/ {print $5}' | \
     r -de "print(summary(X[,1])); stem(X[,1])"
```

which produces something like 

```
   Min. 1st Qu.  Median    Mean 3rd Qu.    Max.
     13     512  110100  486900  768400 4735000

  The decimal point is 6 digit(s) to the right of the |

   0 | 0000001122222279222
   2 | 79444
   4 | 71888
   6 | 
   8 | 
  10 | 
  12 | 
  14 | 8
  16 | 4
  18 | 
  20 | 333
```

(Note that some systems may not have `/boot` in which case you can try `/sbin` or another
directory.)

As we saw in the preceding example, the program can also be shortened like
using the new `-d` option which reads from stdin and assigns to a `data.frame` named `X`. 

And, last but not least, this (somewhat unwieldy) expression can be stored in
a helper script (where we now switch to using an explicit `readLines()` on `stdin`):

```r
#!/usr/bin/env r

fsizes <- as.integer(readLines(file("stdin")))
print(summary(fsizes))
stem(fsizes)
```

(where calling `#!/usr/bin/env` is a trick from Python which allows one
to forget whether r is installed in `/usr/bin/r`, `/usr/local/bin/r`,
`~/bin/r`, ...).


## install.r: Direct CRAN Installation

This is one of my favourite
[littler](http://dirk.eddelbuettel.com/code/littler.html) scripts which I use
frequently to install packages off [CRAN](https://cran.r-project.org).

```r
#!/usr/bin/env r

if (is.null(argv) | length(argv)<1) {
  cat("Usage: installr.r pkg1 [pkg2 pkg3 ...]\n")
  q()
}

## adjust as necessary, see help('download.packages')
repos <- "https://cran.rstudio.com" 

## this makes sense on Debian where no packages touch /usr/local
lib.loc <- "/usr/local/lib/R/site-library"

install.packages(argv, lib.loc, repos)
```

I invoke it all the time with one, two or more packages to install (or
reinstall).

```bash
$ install.r digest RcppCNPy
```

It conveniently installs all dependencies, and uses the chosen target
directory, all while keeping my R prompt (or prompts with multiple sessions)
free to do other things.  Also, if used with `options("Ncpu")` set, then
(remote CRAN) packages will be installed in parallel.

## install2.r: With Cmdline Parsing

Thanks to the fabulous [docopt](https://github.com/edwindj/docopt.R)
package, we also have a variant `install2.r` with optional settings of
repo and location. It was first installed with
[littler 0.2.1](http://dirk.eddelbuettel.com/blog/2014/10/19/).
The current (_i.e._, 0.3.3 as of this writing) version is more featureful and longer and included to keep this brief. Some usage examples are

```sh
$ install2.r -l /tmp/lib Rcpp BH                         # install into given library
$ install2.r -- --with-keep.source drat                  # keep the source
$ install2.r -- --data-compress=bzip2 stringdist         # prefer bz2 compression
```

Another _very_ useful option is `-n N` or `--ncpus N` which will parallelize
the installation across `N` processes.  This can be set automagically by
setting `options("Ncpus")`.

### Installing From Sources

Starting with version 0.2.2, `install.r` and `install2.r` now recognise
installable source files.  So one can also do this: 

```bash
$ install.r digest_0.6.8.tar.gz
```

and the local source file will the installed via a call to `R CMD INSTALL`.


## check.r: Simple Checker

A related use case is to check packages via `check.r`.  This script runs `R
CMD check`, but also installs package dependencies first as tests may have
dependencies not yet satisfied on the test machine.  It offers a number of options:

```bash
$ check.r  -h
Usage: check.r [-h] [-x] [--as-cran] [--repo REPO] [--install-deps] [--install-kitchen] [--deb-pkgs PKGS...] [--use-sudo] [--library LIB] [--setwd DIR] [TARGZ ...]

-a --as-cran          customization similar to CRAN's incoming [default: FALSE]
-r --repo REPO        repository to use, or NULL for file [default: https://cran.rstudio.com]
-i --install-deps     also install packages along with their dependencies [default: FALSE]
-k --install-kitchen  even install packages 'kitchen sink'-style up to suggests [default: FALSE]
-l --library LIB      when installing use this library [default: /usr/local/lib/R/site-library]
-s --setwd DIR        change to this directoru before undertaking the test [default: ]
-d --deb-pkgs PKGS    also install binary .deb packages with their dependencies [default: FALSE]
-u --use-sudo         use sudo when installing .deb packages [default: TRUE]
-h --help             show this help text
-x --usage            show help and short example usage
$
```

## rcc.r: R CMD check wrapper

The script `rcc.r` will also check a source tarball, and offers another set of options:

```bash
$ rcc.r -h
Usage: rcc.r [-h] [-x] [-c] [-f] [-q] [--args ARGS] [--libpath LIBP] [--repos REPO] [PATH...]

-c --as-cran          should '--as-cran' be added to ARGS [default: FALSE]
-a --args ARGS        additional arguments to be passed to 'R CMD CHECK' [default: ]
-l --libpath LIBP     additional library path to be used by 'R CMD CHECK' [default: ]
-r --repos REPO       additional repositories to be used by 'R CMD CHECK' [default: ]
-f --fast             should vignettes and manuals be skipped [default: FALSE]
-q --quiet            should 'rcmdcheck' be called qietly [default: FALSE]
-h --help             show this help text
-x --usage            show help and short example usage
$
```

## build.r: Building Packages

A related script is `build.r` which I often use inside a source repository to quickly build
a source tarball. Like `rcc.r`, it has a switch `-f` or `--fast` to omit building of vignettes.

```bash
$ build.r            # without argument works on current directory
$ build.r digest/    # with directory argument builds tar.gz from repo in directory
```


## installGithub.r: GitHub install

Installation directly from [GitHub](https://github.com) is also popular. Here is an example: 

```bash
$ installGithub.r RcppCore/RcppEigen 
```
Installing from github is supported via the following helper script:

```r
#!/usr/bin/env r
#
# A simple example to install one or more packages from GitHub
#
# Copyright (C) 2014 - 2015  Carl Boettiger and Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt and remotes (or devtools) from CRAN
suppressMessages(library(docopt))       # we need docopt (>= 0.3) as on CRAN
suppressMessages(library(remotes))      # can use devtools as a fallback

## configuration for docopt
doc <- "Usage: installGithub.r [-h] [-d DEPS] REPOS...

-d --deps DEPS      Install suggested dependencies as well? [default: NA]
-h --help           show this help text

where REPOS... is one or more GitHub repositories.

Examples:
  installGithub.r RcppCore/RcppEigen                     

installGithub.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.
"

## docopt parsing
opt <- docopt(doc)
if (opt$deps == "TRUE" || opt$deps == "FALSE") {
    opt$deps <- as.logical(opt$deps)
} else if (opt$deps == "NA") {
    opt$deps <- NA
}

invisible(sapply(opt$REPOS, function(r) install_github(r, dependencies = opt$deps)))
```

## update.r: CRAN package update

One of the scripts I use the most (interactively) is `update.r` which updates installed packages.
An earlier version looked like the following example, the current version is
a little longer and has more features:

```r
#!/usr/bin/env r 
#
# a simple example to update packages in /usr/local/lib/R/site-library
# parameters are easily adjustable

## adjust as necessary, see help('download.packages')
repos <- "https://cloud.r-project.org" 

## this makes sense on Debian where no package touch /usr/local
lib.loc <- "/usr/local/lib/R/site-library"

## r use requires non-interactive use
update.packages(repos=repos, ask=FALSE, lib.loc=lib.loc)

```

As above, it has my preferred mirror and library location hard-wired.

Another _very_ useful option is `-n N` or `--ncpus N` which will parallelize
the upgrade across `N` processes.  This can be set automagically by setting
`options(Ncpus)`.


## knit.r: Calling knitr

Here is another convenience script, `knit.r`,  which _knits_ a given file after
testing the file actually exists.

```r
#!/usr/bin/r
#
# Simple helper script for knitr
#
# Dirk Eddelbuettel, May 2013
#
# GPL-2 or later

if (is.null(argv)) {
    cat("Need an argument FILE.Rnw\n")
    q(status=-1)
}


file <- argv[1]
if (!file.exists(file)) {
    cat("File not found: ", file, "\n")
    q(status=-1)
}

require(knitr)
knit2pdf(file)

```


## roxy.r: Running roxygen

Similar to the previous example, the script `roxy.r` one uses roxygen to extract
documentation from R files -- either in the current directory, or in the
given directory or directories.

```r
#!/usr/bin/r
#
# Simple helper script for roxygen2::roxygenize() 
#
# Dirk Eddelbuettel, August 2013
#
# GPL-2 or later

## load roxygen
library(roxygen2)

## check all command-line arguments (if any are given) for directory status
argv <- Filter(function(x) file.info(x)$is.dir, argv)

## loop over all argument, with fallback of the current directory, and
## call compileAttributes() on the given directory
sapply(ifelse(length(argv) > 0, argv, "."), FUN=roxygenize, roclets="rd")

```

## compAttr.r: Compiling Attributes

The next script, `compAttr.`,  can be used with
[Rcpp](http://dirk.eddelbuettel.com/code/rcpp.html), and particularly is
powerful _Attributes_ feature, in order to auto-generate helper code. It is
similar to the preceding script, but invokes `compileAttributes()` instead.

```r
#!/usr/bin/r
#
# Simple helper script for compileAttributes() 
#
# Dirk Eddelbuettel, July 2014
#
# GPL-2 or later

## load Rcpp
suppressMessages(library(Rcpp))

## check all command-line arguments (if any are given) for directory status
argv <- Filter(function(x) file.info(x)$is.dir, argv)

## loop over all argument, with fallback of the current directory, and
## call compileAttributes() on the given directory
sapply(ifelse(length(argv) > 0, argv, "."), compileAttributes)

```

## render.r: Render Markdown

The `render.r` script generalizes the earlier `knit.r` to convert Markdown
into its designated output.

```r
#!/usr/bin/env r
#
# Another example to run a shiny app
#
# Copyright (C) 2016  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

suppressMessages(library(docopt))       # we need docopt (>= 0.3) as on CRAN

## configuration for docopt
doc <- "Usage: render.r [-h] [-x] [FILES...]

-h --help            show this help text
-x --usage           show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  render.r foo.Rmd bar.Rmd        # convert two given files

render.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

library(rmarkdown)

## helper function 
renderArg <- function(p) {
    if (!file.exists(p)) stop("No file '", p, "' found. Aborting.", call.=FALSE)
    render(p)
}

## render files using helper function 
sapply(opt$FILES, renderArg)

```

---
title: "Littler FAQ"
author: "Dirk Eddelbuettel"
date: "2019-03-23, updated 2020-06-16"
output: 
  minidown::mini_document:
    framework: water
    toc: true
    toc_float: true
    code_folding:
      source: show
      output: show
      message: hide
      warning: hide
      error: hide
vignette: >
  %\VignetteIndexEntry{Littler FAQ}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---


```{css, echo=FALSE}
nav > ul {border: none}
```

### Well, why?

Glad you asked. When the initial work started, `Rscript` did not exist so
there was no scripting tool. We take a small amount of pride into beating
`Rscript` narrowly to a first release.  Of course, by now, `Rscript` is more
widely used as it ships with every R installation but we still have some
aspects we like about `r`: it is simpler and shorter, deals (in our biased)
view more sanely with command-line arguments via the `argv` vector, always
loaded package `methods` (which `Rscript` finally came around to a good
decade later) and [still starts
faster](http://dirk.eddelbuettel.com/blog/2014/09/02/#littler-faster-at-doing-nothing).
And `r` is just to cool a command (in relation to the trusted `R`) so someone
had to!

### No Printing

In the very beginning of `littler`, we made an executive decision to _not_
echo each command output when we evaluate commands in the read-evaluate-print
loop.  So `2+2` will be evaluated silently: four will be computed, but not shown.

That made sense for scripts we wanted to be silent. The idea is that user
will add a `print()` or `cat()` as needed.  If you desire each step to
printed, add a `-p` or `--verbose` argument.


### No `.Renviron`

Another early decision was to make `r` start _faster_ than the alternatives.
Our `r` is "just" a small little binary.  Whereas `R` and `Rscript` are
front-end shell scripts sourcing a number of things and setting them
dynamically, we determine values _at compilation time_ and freeze them into
the binary.  That may seem _risqué_ but worked out just fine.  However, while
we later added the ability to source `Rprofile` files (which contain R code
we can evaluate) there is no way for us to source the `Renviron` files _and
to modify the already running process_.  So if you want to source `Renviron`
you could add an explicit `readEnviron()` to `~/.littler.r` or
`/etc/littler/r`. 

### Lower-case / upper-case

This is mostly an issue on macOS where the brain surgeons behind the OS
decided that `r` is the same as `R`. What can we say?  On that OS you may
need to rename the build to `lr` instead.  Please send your complaints to
Cupertino, California. 

### Adding the binary to your path

When the package is installed from source, it displays 

```
*
* new binary $(TGT) installed in bin/ subdirectory"
* consider adding a symbolic link from, e.g., /usr/local/bin"
* on OS X, you may have to name this 'lr' instead"
* see the littler-faq vignette for more details"
*
```

where the variable `$(TGT)` normally expands to `r`. As the text suggests you may 
want to create a [symbolic link](https://en.wikipedia.org/wiki/Symbolic_link) from a
directory in the to make the newly built binary available to users.  On Linux you 
may do

```
cd /usr/local/bin 
sudo ln -s /usr/local/lib/R/site-library/littler/bin/r .
```

to create a link for `r` in `/usr/local/bin`.  On macOS, as suggested, you may want

```
cd /usr/local/bin 
sudo ln -s /usr/local/lib/R/site-library/littler/bin/r lr
```

to create a command `lr` instead; see the previous question as to why.  In either case
adjust the source part of the `ln` command to where your binary is -- which R can tell 
you via `system.file("bin", "r", package="littler")`.

Also note that _e.g._ the [zsh](http://zsh.sourceforge.net/) has a builtin
command `r` which may conflict, so using the explicit path of, say,
`/usr/bin/r` or `/usr/local/bin/r` or ... may provide an alternative.

---
title: "Littler Examples"
author: "Dirk Eddelbuettel"
date: "Originally written 2015-10-28; Updated 2017-12-10, 2018-05-24, 2019-01-06, 2019-06-09 and 2020-06-16"
output:
  minidown::mini_document:
    framework: water
    toc: true
    toc_float: true
    code_folding:
      source: show
      output: show
      message: hide
      warning: hide
      error: hide
vignette: >
  %\VignetteIndexEntry{Littler Examples}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---

```{css, echo=FALSE}
nav > ul {border: none}
```

## Overview

We show and discuss a few of the files included in the `inst/examples/` source directory of
[littler](http://dirk.eddelbuettel.com/code/littler.html) (which becomes the `examples/` directory 
once installed). In a few cases we remove comment lines to keep things more concise on this page.
We use `$` to denote a shell (_i.e._ terminal) prompt.

Note that some systems (such as macOS) cannot install littler as `r` (as lower-case and upper-case
are by default the same; not a great idea).  And for example the `zsh` has `r` as a builtin so you
would have to use `/usr/bin/r`.  See the [littler FAQ](littler-faq.html) for more.

## Simple Direct Command-line Use

[littler](http://dirk.eddelbuettel.com/code/littler.html) can be used
directly on the command-line just like, say, `bc`, easily consuming standard
input from a pipe: 

```bash
$ echo 'cat(pi^2,"\n")' | r
9.869604
```

Equivalently, commands that are to be evaluated can be given on
the command-line

```bash
$ r -e 'cat(pi^2, "\n")'
9.869604
```

But unlike bc(1), GNU R has a vast number of statistical
functions. For example, we can quickly compute a `summary()` and show
a stem-and-leaf plot for file sizes in a given directory via

```bash
$ ls -l /boot | awk 'BEGIN {print "size"} !/^total/ {print $5}' | \
     r -de "print(summary(X[,1])); stem(X[,1])"
```

which produces something like 

```
   Min. 1st Qu.  Median    Mean 3rd Qu.    Max.
     13     512  110100  486900  768400 4735000

  The decimal point is 6 digit(s) to the right of the |

   0 | 0000001122222279222
   2 | 79444
   4 | 71888
   6 | 
   8 | 
  10 | 
  12 | 
  14 | 8
  16 | 4
  18 | 
  20 | 333
```

(Note that some systems may not have `/boot` in which case you can try `/sbin` or another
directory.)

As we saw in the preceding example, the program can also be shortened like
using the new `-d` option which reads from stdin and assigns to a `data.frame` named `X`. 

And, last but not least, this (somewhat unwieldy) expression can be stored in
a helper script (where we now switch to using an explicit `readLines()` on `stdin`):

```r
#!/usr/bin/env r

fsizes <- as.integer(readLines(file("stdin")))
print(summary(fsizes))
stem(fsizes)
```

(where calling `#!/usr/bin/env` is a trick from Python which allows one
to forget whether r is installed in `/usr/bin/r`, `/usr/local/bin/r`,
`~/bin/r`, ...).


## install.r: Direct CRAN Installation

This is one of my favourite
[littler](http://dirk.eddelbuettel.com/code/littler.html) scripts which I use
frequently to install packages off [CRAN](https://cran.r-project.org).

```r
#!/usr/bin/env r

if (is.null(argv) | length(argv)<1) {
  cat("Usage: installr.r pkg1 [pkg2 pkg3 ...]\n")
  q()
}

## adjust as necessary, see help('download.packages')
repos <- "https://cran.rstudio.com" 

## this makes sense on Debian where no packages touch /usr/local
lib.loc <- "/usr/local/lib/R/site-library"

install.packages(argv, lib.loc, repos)
```

I invoke it all the time with one, two or more packages to install (or
reinstall).

```bash
$ install.r digest RcppCNPy
```

It conveniently installs all dependencies, and uses the chosen target
directory, all while keeping my R prompt (or prompts with multiple sessions)
free to do other things.  Also, if used with `options("Ncpu")` set, then
(remote CRAN) packages will be installed in parallel.

## install2.r: With Cmdline Parsing

Thanks to the fabulous [docopt](https://github.com/edwindj/docopt.R)
package, we also have a variant `install2.r` with optional settings of
repo and location. It was first installed with
[littler 0.2.1](http://dirk.eddelbuettel.com/blog/2014/10/19/).
The current (_i.e._, 0.3.3 as of this writing) version is more featureful and longer and included to keep this brief. Some usage examples are

```sh
$ install2.r -l /tmp/lib Rcpp BH                         # install into given library
$ install2.r -- --with-keep.source drat                  # keep the source
$ install2.r -- --data-compress=bzip2 stringdist         # prefer bz2 compression
```

Another _very_ useful option is `-n N` or `--ncpus N` which will parallelize
the installation across `N` processes.  This can be set automagically by
setting `options("Ncpus")`.

### Installing From Sources

Starting with version 0.2.2, `install.r` and `install2.r` now recognise
installable source files.  So one can also do this: 

```bash
$ install.r digest_0.6.8.tar.gz
```

and the local source file will the installed via a call to `R CMD INSTALL`.


## check.r: Simple Checker

A related use case is to check packages via `check.r`.  This script runs `R
CMD check`, but also installs package dependencies first as tests may have
dependencies not yet satisfied on the test machine.  It offers a number of options:

```bash
$ check.r  -h
Usage: check.r [-h] [-x] [--as-cran] [--repo REPO] [--install-deps] [--install-kitchen] [--deb-pkgs PKGS...] [--use-sudo] [--library LIB] [--setwd DIR] [TARGZ ...]

-a --as-cran          customization similar to CRAN's incoming [default: FALSE]
-r --repo REPO        repository to use, or NULL for file [default: https://cran.rstudio.com]
-i --install-deps     also install packages along with their dependencies [default: FALSE]
-k --install-kitchen  even install packages 'kitchen sink'-style up to suggests [default: FALSE]
-l --library LIB      when installing use this library [default: /usr/local/lib/R/site-library]
-s --setwd DIR        change to this directoru before undertaking the test [default: ]
-d --deb-pkgs PKGS    also install binary .deb packages with their dependencies [default: FALSE]
-u --use-sudo         use sudo when installing .deb packages [default: TRUE]
-h --help             show this help text
-x --usage            show help and short example usage
$
```

## rcc.r: R CMD check wrapper

The script `rcc.r` will also check a source tarball, and offers another set of options:

```bash
$ rcc.r -h
Usage: rcc.r [-h] [-x] [-c] [-f] [-q] [--args ARGS] [--libpath LIBP] [--repos REPO] [PATH...]

-c --as-cran          should '--as-cran' be added to ARGS [default: FALSE]
-a --args ARGS        additional arguments to be passed to 'R CMD CHECK' [default: ]
-l --libpath LIBP     additional library path to be used by 'R CMD CHECK' [default: ]
-r --repos REPO       additional repositories to be used by 'R CMD CHECK' [default: ]
-f --fast             should vignettes and manuals be skipped [default: FALSE]
-q --quiet            should 'rcmdcheck' be called qietly [default: FALSE]
-h --help             show this help text
-x --usage            show help and short example usage
$
```

## build.r: Building Packages

A related script is `build.r` which I often use inside a source repository to quickly build
a source tarball. Like `rcc.r`, it has a switch `-f` or `--fast` to omit building of vignettes.

```bash
$ build.r            # without argument works on current directory
$ build.r digest/    # with directory argument builds tar.gz from repo in directory
```


## installGithub.r: GitHub install

Installation directly from [GitHub](https://github.com) is also popular. Here is an example: 

```bash
$ installGithub.r RcppCore/RcppEigen 
```
Installing from github is supported via the following helper script:

```r
#!/usr/bin/env r
#
# A simple example to install one or more packages from GitHub
#
# Copyright (C) 2014 - 2015  Carl Boettiger and Dirk Eddelbuettel
#
# Released under GPL (>= 2)

## load docopt and remotes (or devtools) from CRAN
suppressMessages(library(docopt))       # we need docopt (>= 0.3) as on CRAN
suppressMessages(library(remotes))      # can use devtools as a fallback

## configuration for docopt
doc <- "Usage: installGithub.r [-h] [-d DEPS] REPOS...

-d --deps DEPS      Install suggested dependencies as well? [default: NA]
-h --help           show this help text

where REPOS... is one or more GitHub repositories.

Examples:
  installGithub.r RcppCore/RcppEigen                     

installGithub.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.
"

## docopt parsing
opt <- docopt(doc)
if (opt$deps == "TRUE" || opt$deps == "FALSE") {
    opt$deps <- as.logical(opt$deps)
} else if (opt$deps == "NA") {
    opt$deps <- NA
}

invisible(sapply(opt$REPOS, function(r) install_github(r, dependencies = opt$deps)))
```

## update.r: CRAN package update

One of the scripts I use the most (interactively) is `update.r` which updates installed packages.
An earlier version looked like the following example, the current version is
a little longer and has more features:

```r
#!/usr/bin/env r 
#
# a simple example to update packages in /usr/local/lib/R/site-library
# parameters are easily adjustable

## adjust as necessary, see help('download.packages')
repos <- "https://cloud.r-project.org" 

## this makes sense on Debian where no package touch /usr/local
lib.loc <- "/usr/local/lib/R/site-library"

## r use requires non-interactive use
update.packages(repos=repos, ask=FALSE, lib.loc=lib.loc)

```

As above, it has my preferred mirror and library location hard-wired.

Another _very_ useful option is `-n N` or `--ncpus N` which will parallelize
the upgrade across `N` processes.  This can be set automagically by setting
`options(Ncpus)`.


## knit.r: Calling knitr

Here is another convenience script, `knit.r`,  which _knits_ a given file after
testing the file actually exists.

```r
#!/usr/bin/r
#
# Simple helper script for knitr
#
# Dirk Eddelbuettel, May 2013
#
# GPL-2 or later

if (is.null(argv)) {
    cat("Need an argument FILE.Rnw\n")
    q(status=-1)
}


file <- argv[1]
if (!file.exists(file)) {
    cat("File not found: ", file, "\n")
    q(status=-1)
}

require(knitr)
knit2pdf(file)

```


## roxy.r: Running roxygen

Similar to the previous example, the script `roxy.r` one uses roxygen to extract
documentation from R files -- either in the current directory, or in the
given directory or directories.

```r
#!/usr/bin/r
#
# Simple helper script for roxygen2::roxygenize() 
#
# Dirk Eddelbuettel, August 2013
#
# GPL-2 or later

## load roxygen
library(roxygen2)

## check all command-line arguments (if any are given) for directory status
argv <- Filter(function(x) file.info(x)$is.dir, argv)

## loop over all argument, with fallback of the current directory, and
## call compileAttributes() on the given directory
sapply(ifelse(length(argv) > 0, argv, "."), FUN=roxygenize, roclets="rd")

```

## compAttr.r: Compiling Attributes

The next script, `compAttr.`,  can be used with
[Rcpp](http://dirk.eddelbuettel.com/code/rcpp.html), and particularly is
powerful _Attributes_ feature, in order to auto-generate helper code. It is
similar to the preceding script, but invokes `compileAttributes()` instead.

```r
#!/usr/bin/r
#
# Simple helper script for compileAttributes() 
#
# Dirk Eddelbuettel, July 2014
#
# GPL-2 or later

## load Rcpp
suppressMessages(library(Rcpp))

## check all command-line arguments (if any are given) for directory status
argv <- Filter(function(x) file.info(x)$is.dir, argv)

## loop over all argument, with fallback of the current directory, and
## call compileAttributes() on the given directory
sapply(ifelse(length(argv) > 0, argv, "."), compileAttributes)

```

## render.r: Render Markdown

The `render.r` script generalizes the earlier `knit.r` to convert Markdown
into its designated output.

```r
#!/usr/bin/env r
#
# Another example to run a shiny app
#
# Copyright (C) 2016  Dirk Eddelbuettel
#
# Released under GPL (>= 2)

suppressMessages(library(docopt))       # we need docopt (>= 0.3) as on CRAN

## configuration for docopt
doc <- "Usage: render.r [-h] [-x] [FILES...]

-h --help            show this help text
-x --usage           show help and short example usage"

opt <- docopt(doc)			# docopt parsing

if (opt$usage) {
    cat(doc, "\n\n")
    cat("Examples:
  render.r foo.Rmd bar.Rmd        # convert two given files

render.r is part of littler which brings 'r' to the command-line.
See http://dirk.eddelbuettel.com/code/littler.html for more information.\n")
    q("no")
}

library(rmarkdown)

## helper function 
renderArg <- function(p) {
    if (!file.exists(p)) stop("No file '", p, "' found. Aborting.", call.=FALSE)
    render(p)
}

## render files using helper function 
sapply(opt$FILES, renderArg)

```

\name{littler}
\alias{littler}
\title{Command-line and scripting front-end for R}
\description{
  The \code{r} \emph{binary} provides a convenient and powerful front-end.
  By embedding R, it permits four distinct ways to leverage the power of R at
  the shell prompt: scripting, filename execution, piping and direct expression
  evaluation.
}
\details{
  The \code{r} front-end was written with four distinct usage modes in mind.

  First, it allow to write so-called \sQuote{shebang} scripts starting with
  \code{#!/usr/bin/env r}. These \sQuote{shebang} scripts are
  perfectly suited for automation and execution via e.g. via \code{cron}.

  Second, we can use \code{r somefile.R} to quickly execute the name R source file.
  This is useful as \code{r} is both easy to type---and quicker to start that either
  \code{R} itself, or its scripting tool \code{Rscript}, while still loading the
  \code{methods} package.

  Third, \code{r} can be used in \sQuote{pipes} which are very common in Unix. A
  simple and trivial example is \code{echo 'cat(2+2)' | r} illustrating that the
  standard output of one program can be used as the standard input of another
  program.

  Fourth, \code{r} can be used as a calculator by supplying expressions after the
  \code{-e} or \code{--eval} options.
}
\value{
  Common with other shell tools and programs, \code{r} returns its exit code where
  a value of zero indicates success.
}
\note{
  On OS X one may have to link the binary to, say, \code{lr} instead. As OS X
  insists that files named \code{R} and \code{r} are the same, we cannot use the
  latter.
}
\author{
  Jeff Horner and Dirk Eddelbuettel wrote \code{littler} from 2006 to today, with
  contributions from several others.

  Dirk Eddelbuettel \email{edd@debian.org} is the maintainer.
}
\examples{
  \dontrun{
  #!/usr/bin/env r              ## for use in scripts

  other input | r               ## for use in pipes

  r somefile.R                  ## for running files

  r -e 'expr'                   ## for evaluating expressions

  r --help                      ## to show a quick synopsis
        
  }
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/test.R
\name{r}
\alias{r}
\title{Return Path to \code{r} Binary}
\usage{
r(usecat = FALSE)
}
\arguments{
\item{usecat}{Optional toggle to request output to stdout (useful in Makefiles)}
}
\value{
The path is returned as character variable. If the \code{usecat} option is
set the character variable is displayed via \code{\link{cat}} instead.
}
\description{
Return the path of the install \code{r} binary.
}
\details{
The test for Windows is of course superfluous as we have no binary for Windows.
Maybe one day...
}
\author{
Dirk Eddelbuettel
}
